#
# spec file for package gcc47
#
# Copyright (c) 2013 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild
# icecream 0

%define run_tests 1
%define build_optional_compiler_languages 1
#
# spec file for package gcc47
#
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# Ada currently fails to build on a few platforms, enable it only
# on those that work
# Note that AdaCore only supports %ix86, x86_64 and ia64
%ifarch %ix86 x86_64 ppc s390 ia64
%define build_ada !0%{?building_libjava:1}%{?building_libffi:1}
%else
# alpha ppc64 s390x hppa arm
%define build_ada 0
%endif

%define quadmath_arch %ix86 x86_64 ia64

# We don't want to build java
%ifarch mips
%define build_java 0
%define build_libjava 0
%else
%define build_java 1
%define build_libjava 0%{?building_libjava:1}%{?building_libffi:1}%{?building_testsuite:1}
%endif

%define build_cp 1
%define build_fortran 1
%define build_objc 1
%define build_objcp !0%{?building_libjava:1}%{?building_libffi:1}
%define build_with_mudflap 0

%if %{build_objcp}
%define build_cp 1
%define build_objc 1
%endif

%if %{build_libjava}
%define build_cp 1
%endif

# For optional compilers only build C, C++ and Fortran
%if 0%{?build_optional_compiler_languages:1}
%define build_ada 0
%define build_java 0
%define build_libjava 0
%define build_objc 0
%define build_objcp 0
%endif

# Shared library SONAME versions
%ifarch hppa
%define libgcc_s 4
%else
%define libgcc_s 1
%endif
%define gcj_sover 13
%define libgcj_bc_sover 1
%define libffi_sover 4
%define libmudflap_sover 0
%define libgomp_sover 1
%define libstdcxx_sover 6
%define libobjc_sover 4
%define libgfortran_sover 3
%define libquadmath_sover 0

Name:           gcc47
BuildRequires:  bison
BuildRequires:  flex
BuildRequires:  gettext-devel
BuildRequires:  glibc-devel-32bit glibc-32bit
BuildRequires:  mpc-devel
BuildRequires:  mpfr-devel
BuildRequires:  perl
%if %{suse_version} > 1220
BuildRequires:  makeinfo
%else
BuildRequires:  texinfo
%endif
BuildRequires:  zlib-devel
%ifarch %ix86 x86_64 ppc ppc64 s390 s390x ia64 %sparc hppa %arm
BuildRequires:  cloog-devel
BuildRequires:  ppl-devel
%endif
%if %{build_ada}
%if %{suse_version} > 1220
%define hostsuffix -4.7
BuildRequires:  gcc47-ada
%else
%define hostsuffix %{nil}
BuildRequires:  gcc-ada
%endif
%endif
%if 0%{?building_libjava:1}%{?building_testsuite:1}
BuildRequires:  fastjar
BuildRequires:  unzip
%endif
%if 0%{?building_libffi:1}
BuildRequires:  pkg-config
%endif
%ifarch ia64
BuildRequires:  libunwind-devel
%endif
%if 0%{?run_tests:1}
BuildRequires:  dejagnu
BuildRequires:  expect
BuildRequires:  gdb
%endif

%ifarch ppc
# We support building the nof libraries, but don't want this in the
# regular rpms
%define build_nof 0
%else
%define build_nof 0
%endif

%define separate_bi32 0
%define separate_bi64 0
%ifarch ppc sparcv9
# Beware, this does _not_ separate libgcj, as for that one multilibing
# is inactive for the time being
%define separate_bi64 1
%endif
%ifarch x86_64 s390x ppc64 sparc64
%define separate_bi32 1
%endif

# Define two macros to trigger -32bit or -64bit package variants
%define separate_biarch 0
%if %{separate_bi32}
%define separate_biarch 1
%define separate_biarch_suffix -32bit
%endif
%if %{separate_bi64}
%define separate_biarch 1
%define separate_biarch_suffix -64bit
%endif

%ifarch x86_64 ia64 s390x alpha ppc64 sparc64
# 64-bit is primary build target
%define build_primary_64bit 1
%else
%define build_primary_64bit 0
%endif

%define biarch_libjava 0

# COMMON-BEGIN
%define biarch_targets x86_64 s390x powerpc64 powerpc sparc sparc64

Url:            http://gcc.gnu.org/
Version:        4.7.2_20130108
Release:        1.3
%define gcc_version %(echo %version | sed 's/_.*//')
%define gcc_dir_version %(echo %gcc_version | cut -d '.' -f 1-2)
%define snapshot_date %(echo %version | sed 's/[34]\.[0-9]\.[0-6]//' | sed 's/_/-/')
%define binsuffix -4.7
# COMMON-END

%if !0%{?building_libjava:1}%{?building_libffi:1}%{?building_testsuite:1}
Requires:       binutils glibc-devel
Requires:       cpp47 = %{version}-%{release}
Requires:       libgcc_s%{libgcc_s} >= %{version}-%{release}
Requires:       libgomp%{libgomp_sover} >= %{version}-%{release}
%if %{build_with_mudflap}
Requires:       libmudflap%{libmudflap_sover} >= %{version}-%{release}
Requires:       libmudflapth%{libmudflap_sover} >= %{version}-%{release}
%endif
%if 0%{suse_version} > 1000
Suggests:       gcc47-info gcc47-locale
%endif
%endif

# COMMON-BEGIN
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Source:         gcc-%{gcc_version}%{snapshot_date}.tar.bz2
Source1:        change_spec
Source2:        libgcj47-rpmlintrc
Source3:        gcc47-rpmlintrc
Source4:        ecj.jar
Source5:        README.First-for.SuSE.packagers
Source6:        baselibs.conf
Patch1:         gcc-dir-version.patch
Patch2:         gcc-sles-version.patch
Patch3:         gcc-noalias-warn.diff
Patch6:         suse-record-gcc-opts.diff
Patch7:         gcc-add-defaultsspec.diff
Patch8:         Wunprototyped-calls.diff
Patch10:        program-transform-name.diff
Patch12:        gcc4-ppc64-m32-m64-multilib-only.patch
Patch23:        libjava-no-multilib.diff
Patch24:        tls-no-direct.diff
Patch30:        gcc43-no-unwind-tables.diff
Patch32:        pr49484.diff
Patch33:        gcc-arm-linker.patch
# A set of patches from the RH srpm
Patch51:        gcc41-ia64-stack-protector.patch
Patch55:        gcc41-java-slow_pthread_self.patch
Patch57:        gcc41-ppc32-retaddr.patch
# Some patches taken from Debian
Patch60:        gcc44-textdomain.patch
Patch61:        gcc44-rename-info-files.patch
# Patches for SAP features
Patch130:       sap303956-uchar.diff
# Some other features
Patch200:       gcc-btver2.diff
Patch201:       gcc47-ibm-zEC12.diff

# GCC-TESTSUITE-DELETE-BEGIN
# LIBFFI-DELETE-BEGIN
# LIBJAVA-DELETE-BEGIN
Group:          Development/Languages/C and C++
Summary:        The GNU C Compiler and Support Files
License:        GPL-3.0+

%description
Core package for the GNU Compiler Collection, including the C language
frontend.

Language frontends other than C are split to different sub-packages,
namely gcc-ada, gcc-c++, gcc-fortran, gcc-java, gcc-objc and
gcc-obj-c++.



# COMMON-END
%package -n gcc47-32bit

Summary:        The GNU C Compiler 32bit support
Group:          Development/Languages/C and C++
Requires:       gcc47 = %{version}-%{release}
Requires:       libgcc_s%{libgcc_s}-32bit >= %{version}-%{release}
Requires:       libgomp%{libgomp_sover}-32bit >= %{version}-%{release}
%if %{build_with_mudflap}
Requires:       libmudflap%{libmudflap_sover}-32bit >= %{version}-%{release}
Requires:       libmudflapth%{libmudflap_sover}-32bit >= %{version}-%{release}
%endif
Requires:       glibc-devel-32bit glibc-32bit

%description -n gcc47-32bit
This package contains 32bit support for the GNU Compiler Collection.

%package -n gcc47-64bit

Summary:        The GNU C Compiler 64bit support
Group:          Development/Languages/C and C++
Requires:       gcc47 = %{version}-%{release}
Requires:       libgcc_s%{libgcc_s}-64bit >= %{version}-%{release}
Requires:       libgomp%{libgomp_sover}-64bit >= %{version}-%{release}
%if %{build_with_mudflap}
Requires:       libmudflap%{libmudflap_sover}-64bit >= %{version}-%{release}
Requires:       libmudflapth%{libmudflap_sover}-64bit >= %{version}-%{release}
%endif
Requires:       glibc-devel-64bit

%description -n gcc47-64bit
This package contains 64bit support for the GNU Compiler Collection.


%package locale
Summary:        Locale Data for the GNU Compiler Collection
License:        GPL-3.0+
Group:          Development/Languages/C and C++
Requires:       gcc47 = %{version}-%{release}

%description locale
Locale data for the GNU Compiler Collection (GCC) to give error message
in the current locale.


%package c++
Summary:        The GNU C++ Compiler
License:        GPL-3.0+
Group:          Development/Languages/C and C++
Requires:       gcc47 = %{version}-%{release}
Requires:       libstdc++47-devel = %{version}-%{release}

%description c++
This package contains the GNU compiler for C++.

# PACKAGE-BEGIN
# PACKAGE-BEGIN
%package -n libstdc++47-devel
Summary:        Include Files and Libraries mandatory for Development
License:        GPL-3.0-with-GCC-exception
Group:          Development/Languages/C and C++
Requires:       libstdc++%{libstdcxx_sover} >= %{version}-%{release}
Requires:       glibc-devel
%ifarch ia64
Requires:       libunwind-devel
%endif

%description -n libstdc++47-devel
This package contains all the headers and libraries of the standard C++
library. It is needed for compiling C++ code.
# PACKAGE-END
# PACKAGE-BEGIN
# PACKAGE-BEGIN
%package -n libstdc++47-devel-32bit
Summary:        Include Files and Libraries mandatory for Development
License:        GPL-3.0-with-GCC-exception
Group:          Development/Languages/C and C++
Requires:       libstdc++%{libstdcxx_sover}-32bit >= %{version}-%{release}
Requires:       glibc-devel-32bit glibc-32bit
%ifarch ia64
Requires:       libunwind-devel
%endif

%description -n libstdc++47-devel-32bit
This package contains all the headers and libraries of the standard C++
library. It is needed for compiling C++ code.
# PACKAGE-END
# PACKAGE-BEGIN
# PACKAGE-BEGIN
%package -n libstdc++47-devel-64bit
Summary:        Include Files and Libraries mandatory for Development
License:        GPL-3.0-with-GCC-exception
Group:          Development/Languages/C and C++
Requires:       libstdc++%{libstdcxx_sover}-64bit >= %{version}-%{release}
Requires:       glibc-devel-64bit
%ifarch ia64
Requires:       libunwind-devel
%endif

%description -n libstdc++47-devel-64bit
This package contains all the headers and libraries of the standard C++
library. It is needed for compiling C++ code.
# PACKAGE-END

%package -n libstdc++47-doc
Summary:        Documentation for the GNU C++ standard library
License:        GPL-3.0+
Group:          Documentation/HTML
%if 0%{?suse_version} >= 1120
BuildArch:      noarch
%endif

%description -n libstdc++47-doc
Extensive HTML documentation for the GNU C++ standard library.


# PACKAGE-BEGIN
# PACKAGE-BEGIN
%package -n libgcc_s%{libgcc_s}

Summary:        C compiler runtime library
License:        GPL-3.0-with-GCC-exception
Group:          System/Base
# Only one package may provide this - allows multiple gcc versions
# to co-exist without an overly large list of provides/obsoletes
Conflicts:      libgcc_s%{libgcc_s} < %{version}-%{release}
# Old libgcc packages provided a wrong shlib policy compatible name
Provides:       libgcc%{libgcc_s} = %{version}-%{release}
Conflicts:      libgcc%{libgcc_s} < %{version}-%{release}

%description -n libgcc_s%{libgcc_s}
Libgcc is needed for dynamically linked C programs.

%post -n libgcc_s%{libgcc_s}
/sbin/ldconfig

%postun -n libgcc_s%{libgcc_s}
/sbin/ldconfig
# PACKAGE-END
# PACKAGE-BEGIN
# PACKAGE-BEGIN

%package -n libgcc_s%{libgcc_s}-32bit

Summary:        C compiler runtime library
License:        GPL-3.0-with-GCC-exception
Group:          System/Base
# Only one package may provide this - allows multiple gcc versions
# to co-exist without an overly large list of provides/obsoletes
Conflicts:      libgcc_s%{libgcc_s}-32bit < %{version}-%{release}
# Old libgcc packages provided a wrong shlib policy compatible name
Provides:       libgcc%{libgcc_s}-32bit = %{version}-%{release}
Conflicts:      libgcc%{libgcc_s}-32bit < %{version}-%{release}

%description -n libgcc_s%{libgcc_s}-32bit
Libgcc is needed for dynamically linked C programs.

%post -n libgcc_s%{libgcc_s}-32bit
/sbin/ldconfig

%postun -n libgcc_s%{libgcc_s}-32bit
/sbin/ldconfig
# PACKAGE-END
# PACKAGE-BEGIN
# PACKAGE-BEGIN

%package -n libgcc_s%{libgcc_s}-64bit

Summary:        C compiler runtime library
License:        GPL-3.0-with-GCC-exception
Group:          System/Base
# Only one package may provide this - allows multiple gcc versions
# to co-exist without an overly large list of provides/obsoletes
Conflicts:      libgcc_s%{libgcc_s}-64bit < %{version}-%{release}
# Old libgcc packages provided a wrong shlib policy compatible name
Provides:       libgcc%{libgcc_s}-64bit = %{version}-%{release}
Conflicts:      libgcc%{libgcc_s}-64bit < %{version}-%{release}

%description -n libgcc_s%{libgcc_s}-64bit
Libgcc is needed for dynamically linked C programs.

%post -n libgcc_s%{libgcc_s}-64bit
/sbin/ldconfig

%postun -n libgcc_s%{libgcc_s}-64bit
/sbin/ldconfig
# PACKAGE-END

# PACKAGE-BEGIN
# PACKAGE-BEGIN

%package -n libgomp%{libgomp_sover}

Summary:        The GNU compiler collection OpenMP runtime library
License:        GPL-3.0-with-GCC-exception
Group:          System/Base
# Only one package may provide this - allows multiple gcc versions
# to co-exist without an overly large list of provides/obsoletes
Conflicts:      libgomp%{libgomp_sover} < %{version}-%{release}

%description -n libgomp%{libgomp_sover}
This is the OpenMP runtime library needed by OpenMP enabled programs
that were built with the -fopenmp compiler option and by programs that
were auto-parallelized via the -ftree-parallelize-loops compiler
option.


%post -n libgomp%{libgomp_sover}
/sbin/ldconfig

%postun -n libgomp%{libgomp_sover}
/sbin/ldconfig
# PACKAGE-END
# PACKAGE-BEGIN
# PACKAGE-BEGIN

%package -n libgomp%{libgomp_sover}-32bit

Summary:        The GNU compiler collection OpenMP runtime library
License:        GPL-3.0-with-GCC-exception
Group:          System/Base
# Only one package may provide this - allows multiple gcc versions
# to co-exist without an overly large list of provides/obsoletes
Conflicts:      libgomp%{libgomp_sover}-32bit < %{version}-%{release}

%description -n libgomp%{libgomp_sover}-32bit
This is the OpenMP runtime library needed by OpenMP enabled programs
that were built with the -fopenmp compiler option and by programs that
were auto-parallelized via the -ftree-parallelize-loops compiler
option.


%post -n libgomp%{libgomp_sover}-32bit
/sbin/ldconfig

%postun -n libgomp%{libgomp_sover}-32bit
/sbin/ldconfig
# PACKAGE-END
# PACKAGE-BEGIN
# PACKAGE-BEGIN

%package -n libgomp%{libgomp_sover}-64bit

Summary:        The GNU compiler collection OpenMP runtime library
License:        GPL-3.0-with-GCC-exception
Group:          System/Base
# Only one package may provide this - allows multiple gcc versions
# to co-exist without an overly large list of provides/obsoletes
Conflicts:      libgomp%{libgomp_sover}-64bit < %{version}-%{release}

%description -n libgomp%{libgomp_sover}-64bit
This is the OpenMP runtime library needed by OpenMP enabled programs
that were built with the -fopenmp compiler option and by programs that
were auto-parallelized via the -ftree-parallelize-loops compiler
option.


%post -n libgomp%{libgomp_sover}-64bit
/sbin/ldconfig

%postun -n libgomp%{libgomp_sover}-64bit
/sbin/ldconfig
# PACKAGE-END

# PACKAGE-BEGIN
# PACKAGE-BEGIN

%package -n libstdc++%{libstdcxx_sover}

Summary:        The standard C++ shared library
License:        GPL-3.0-with-GCC-exception
Group:          System/Libraries
# Only one package may provide this - allows multiple gcc versions
# to co-exist without an overly large list of provides/obsoletes
Conflicts:      libstdc++%{libstdcxx_sover} < %{version}-%{release}

%description -n libstdc++%{libstdcxx_sover}
The standard C++ library, needed for dynamically linked C++ programs.


%post -n libstdc++%{libstdcxx_sover}
/sbin/ldconfig

%postun -n libstdc++%{libstdcxx_sover}
/sbin/ldconfig
# PACKAGE-END
# PACKAGE-BEGIN
# PACKAGE-BEGIN

%package -n libstdc++%{libstdcxx_sover}-32bit

Summary:        The standard C++ shared library
License:        GPL-3.0-with-GCC-exception
Group:          System/Libraries
# Only one package may provide this - allows multiple gcc versions
# to co-exist without an overly large list of provides/obsoletes
Conflicts:      libstdc++%{libstdcxx_sover}-32bit < %{version}-%{release}

%description -n libstdc++%{libstdcxx_sover}-32bit
The standard C++ library, needed for dynamically linked C++ programs.


%post -n libstdc++%{libstdcxx_sover}-32bit
/sbin/ldconfig

%postun -n libstdc++%{libstdcxx_sover}-32bit
/sbin/ldconfig
# PACKAGE-END
# PACKAGE-BEGIN
# PACKAGE-BEGIN

%package -n libstdc++%{libstdcxx_sover}-64bit

Summary:        The standard C++ shared library
License:        GPL-3.0-with-GCC-exception
Group:          System/Libraries
# Only one package may provide this - allows multiple gcc versions
# to co-exist without an overly large list of provides/obsoletes
Conflicts:      libstdc++%{libstdcxx_sover}-64bit < %{version}-%{release}

%description -n libstdc++%{libstdcxx_sover}-64bit
The standard C++ library, needed for dynamically linked C++ programs.


%post -n libstdc++%{libstdcxx_sover}-64bit
/sbin/ldconfig

%postun -n libstdc++%{libstdcxx_sover}-64bit
/sbin/ldconfig
# PACKAGE-END

%package info
Summary:        Documentation for the GNU compiler collection
License:        GFDL-1.2
Group:          Documentation/Other
PreReq:         %{install_info_prereq}
%if 0%{?suse_version} >= 1120
BuildArch:      noarch
%endif

%description info
GNU info-pages for the GNU compiler collection covering both user-level
and internals documentation.


# PACKAGE-BEGIN
# PACKAGE-BEGIN
%package objc
Summary:        GNU Objective C Compiler
License:        GPL-3.0+
Group:          Development/Languages/Other
Requires:       gcc47 = %{version}-%{release}
Requires:       libobjc%{libobjc_sover} >= %{version}-%{release}

%description objc
This package contains the GNU Objective C compiler. Objective C is an
object oriented language, created by Next Inc. and used in their
Nextstep OS. The source code is available in the gcc package.
# PACKAGE-END
# PACKAGE-BEGIN
# PACKAGE-BEGIN
%package objc-32bit
Summary:        GNU Objective C Compiler
License:        GPL-3.0+
Group:          Development/Languages/Other
Requires:       gcc47 = %{version}-%{release}
Requires:       libobjc%{libobjc_sover}-32bit >= %{version}-%{release}

%description objc-32bit
This package contains the GNU Objective C compiler. Objective C is an
object oriented language, created by Next Inc. and used in their
Nextstep OS. The source code is available in the gcc package.
# PACKAGE-END
# PACKAGE-BEGIN
# PACKAGE-BEGIN
%package objc-64bit
Summary:        GNU Objective C Compiler
License:        GPL-3.0+
Group:          Development/Languages/Other
Requires:       gcc47 = %{version}-%{release}
Requires:       libobjc%{libobjc_sover}-64bit >= %{version}-%{release}

%description objc-64bit
This package contains the GNU Objective C compiler. Objective C is an
object oriented language, created by Next Inc. and used in their
Nextstep OS. The source code is available in the gcc package.
# PACKAGE-END

# PACKAGE-BEGIN
# PACKAGE-BEGIN
%package -n libobjc%{libobjc_sover}

Summary:        Library for the GNU Objective C Compiler
License:        GPL-3.0-with-GCC-exception
Group:          Development/Libraries/Other
# Only one package may provide this - allows multiple gcc versions
# to co-exist without an overly large list of provides/obsoletes
Conflicts:      libobjc%{libobjc_sover} < %{version}-%{release}

%description -n libobjc%{libobjc_sover}
The library for the GNU Objective C compiler.

%post -n libobjc%{libobjc_sover}
/sbin/ldconfig

%postun -n libobjc%{libobjc_sover}
/sbin/ldconfig
# PACKAGE-END
# PACKAGE-BEGIN
# PACKAGE-BEGIN

%package -n libobjc%{libobjc_sover}-32bit

Summary:        Library for the GNU Objective C Compiler
License:        GPL-3.0-with-GCC-exception
Group:          Development/Libraries/Other
# Only one package may provide this - allows multiple gcc versions
# to co-exist without an overly large list of provides/obsoletes
Conflicts:      libobjc%{libobjc_sover}-32bit < %{version}-%{release}

%description -n libobjc%{libobjc_sover}-32bit
The library for the GNU Objective C compiler.

%post -n libobjc%{libobjc_sover}-32bit
/sbin/ldconfig

%postun -n libobjc%{libobjc_sover}-32bit
/sbin/ldconfig
# PACKAGE-END
# PACKAGE-BEGIN
# PACKAGE-BEGIN

%package -n libobjc%{libobjc_sover}-64bit

Summary:        Library for the GNU Objective C Compiler
License:        GPL-3.0-with-GCC-exception
Group:          Development/Libraries/Other
# Only one package may provide this - allows multiple gcc versions
# to co-exist without an overly large list of provides/obsoletes
Conflicts:      libobjc%{libobjc_sover}-64bit < %{version}-%{release}

%description -n libobjc%{libobjc_sover}-64bit
The library for the GNU Objective C compiler.

%post -n libobjc%{libobjc_sover}-64bit
/sbin/ldconfig

%postun -n libobjc%{libobjc_sover}-64bit
/sbin/ldconfig
# PACKAGE-END

%package obj-c++
Summary:        GNU Objective C++ Compiler
License:        GPL-3.0+
Group:          Development/Languages/Other
Requires:       gcc47-objc = %{version}-%{release}
Requires:       gcc47-c++ = %{version}-%{release}

%description obj-c++
This package contains the GNU Objective C++ compiler. Objective C++ is an
object oriented language, created by Next Inc. and used in their
Nextstep OS. The source code is available in the gcc package.


%package -n cpp47
Summary:        The GCC Preprocessor
License:        GPL-3.0+
Group:          Development/Languages/C and C++

%description -n cpp47
This Package contains just the preprocessor that is used by the X11
packages.


# PACKAGE-BEGIN
# PACKAGE-BEGIN
%package ada
Summary:        GNU Ada95 Compiler Based on GCC (GNAT)
License:        GPL-3.0+
Group:          Development/Languages/Other
Requires:       gcc47 = %{version}-%{release}
Requires:       libada47 = %{version}-%{release}

%description ada
This package contains an Ada95 compiler and associated development
tools based on the GNU GCC technology. Ada95 is the object oriented
successor of the Ada83 language. To build this package from source you
must have installed a binary version to bootstrap the compiler.
# PACKAGE-END
# PACKAGE-BEGIN
# PACKAGE-BEGIN
%package ada-32bit
Summary:        GNU Ada95 Compiler Based on GCC (GNAT)
License:        GPL-3.0+
Group:          Development/Languages/Other
Requires:       gcc47-32bit = %{version}-%{release}
Requires:       libada47-32bit = %{version}-%{release}

%description ada-32bit
This package contains an Ada95 compiler and associated development
tools based on the GNU GCC technology. Ada95 is the object oriented
successor of the Ada83 language. To build this package from source you
must have installed a binary version to bootstrap the compiler.
# PACKAGE-END
# PACKAGE-BEGIN
# PACKAGE-BEGIN
%package ada-64bit
Summary:        GNU Ada95 Compiler Based on GCC (GNAT)
License:        GPL-3.0+
Group:          Development/Languages/Other
Requires:       gcc47-64bit = %{version}-%{release}
Requires:       libada47-64bit = %{version}-%{release}

%description ada-64bit
This package contains an Ada95 compiler and associated development
tools based on the GNU GCC technology. Ada95 is the object oriented
successor of the Ada83 language. To build this package from source you
must have installed a binary version to bootstrap the compiler.
# PACKAGE-END

# PACKAGE-BEGIN
# PACKAGE-BEGIN
%package -n libada47
Summary:        GNU Ada Runtime Libraries
License:        GPL-3.0-with-GCC-exception
Group:          System/Libraries
Provides:       libgnarl-4_7 = %{version}-%{release}
Conflicts:      libgnarl-4_7 < %{version}-%{release}
Provides:       libgnat-4_7 = %{version}-%{release}
Conflicts:      libgnat-4_7 < %{version}-%{release}

%description -n libada47
This package contains the shared libraries required to run programs
compiled with the GNU Ada compiler (GNAT) if they are compiled to use
shared libraries. It also contains the shared libraries for the
Implementation of the Ada Semantic Interface Specification (ASIS), the
implementation of Distributed Systems Programming (GLADE) and the Posix
1003.5 Binding (Florist).

%post -n libada47
/sbin/ldconfig

%postun -n libada47
/sbin/ldconfig
# PACKAGE-END
# PACKAGE-BEGIN
# PACKAGE-BEGIN

%package -n libada47-32bit
Summary:        GNU Ada Runtime Libraries
License:        GPL-3.0-with-GCC-exception
Group:          System/Libraries
Provides:       libgnarl-4_7-32bit = %{version}-%{release}
Conflicts:      libgnarl-4_7-32bit < %{version}-%{release}
Provides:       libgnat-4_7-32bit = %{version}-%{release}
Conflicts:      libgnat-4_7-32bit < %{version}-%{release}

%description -n libada47-32bit
This package contains the shared libraries required to run programs
compiled with the GNU Ada compiler (GNAT) if they are compiled to use
shared libraries. It also contains the shared libraries for the
Implementation of the Ada Semantic Interface Specification (ASIS), the
implementation of Distributed Systems Programming (GLADE) and the Posix
1003.5 Binding (Florist).

%post -n libada47-32bit
/sbin/ldconfig

%postun -n libada47-32bit
/sbin/ldconfig
# PACKAGE-END
# PACKAGE-BEGIN
# PACKAGE-BEGIN

%package -n libada47-64bit
Summary:        GNU Ada Runtime Libraries
License:        GPL-3.0-with-GCC-exception
Group:          System/Libraries
Provides:       libgnarl-4_7-64bit = %{version}-%{release}
Conflicts:      libgnarl-4_7-64bit < %{version}-%{release}
Provides:       libgnat-4_7-64bit = %{version}-%{release}
Conflicts:      libgnat-4_7-64bit < %{version}-%{release}

%description -n libada47-64bit
This package contains the shared libraries required to run programs
compiled with the GNU Ada compiler (GNAT) if they are compiled to use
shared libraries. It also contains the shared libraries for the
Implementation of the Ada Semantic Interface Specification (ASIS), the
implementation of Distributed Systems Programming (GLADE) and the Posix
1003.5 Binding (Florist).

%post -n libada47-64bit
/sbin/ldconfig

%postun -n libada47-64bit
/sbin/ldconfig
# PACKAGE-END

# PACKAGE-BEGIN
# PACKAGE-BEGIN

%package fortran
Summary:        The GNU Fortran Compiler and Support Files
License:        GPL-3.0+
Group:          Development/Languages/Fortran
Requires:       gcc47 = %{version}-%{release}
Requires:       libgfortran%{libgfortran_sover} >= %{version}-%{release}
%ifarch %quadmath_arch
Requires:       libquadmath%{libquadmath_sover} >= %{version}-%{release}
%endif

%description fortran
This is the Fortran compiler of the GNU Compiler Collection (GCC).
# PACKAGE-END
# PACKAGE-BEGIN
# PACKAGE-BEGIN
%package fortran-32bit
Summary:        The GNU Fortran Compiler and Support Files
License:        GPL-3.0+
Group:          Development/Languages/Fortran
Requires:       gcc47 = %{version}-%{release}
Requires:       libgfortran%{libgfortran_sover}-32bit >= %{version}-%{release}
%ifarch %quadmath_arch
Requires:       libquadmath%{libquadmath_sover}-32bit >= %{version}-%{release}
%endif

%description fortran-32bit
This is the Fortran compiler of the GNU Compiler Collection (GCC).
# PACKAGE-END
# PACKAGE-BEGIN
# PACKAGE-BEGIN
%package fortran-64bit
Summary:        The GNU Fortran Compiler and Support Files
License:        GPL-3.0+
Group:          Development/Languages/Fortran
Requires:       gcc47 = %{version}-%{release}
Requires:       libgfortran%{libgfortran_sover}-64bit >= %{version}-%{release}
%ifarch %quadmath_arch
Requires:       libquadmath%{libquadmath_sover}-64bit >= %{version}-%{release}
%endif

%description fortran-64bit
This is the Fortran compiler of the GNU Compiler Collection (GCC).
# PACKAGE-END

# PACKAGE-BEGIN
# PACKAGE-BEGIN
%package -n libgfortran%{libgfortran_sover}

Summary:        The GNU Fortran Compiler Runtime Library
License:        GPL-3.0-with-GCC-exception
Group:          Development/Languages/Fortran
%ifarch %quadmath_arch
Requires:       libquadmath%{libquadmath_sover} >= %{version}-%{release}
%endif
# Only one package may provide this - allows multiple gcc versions
# to co-exist without an overly large list of provides/obsoletes
Conflicts:      libgfortran%{libgfortran_sover} < %{version}-%{release}

%description -n libgfortran%{libgfortran_sover}
The runtime library needed to run programs compiled with the Fortran compiler
of the GNU Compiler Collection (GCC).

%post -n libgfortran%{libgfortran_sover}
/sbin/ldconfig

%postun -n libgfortran%{libgfortran_sover}
/sbin/ldconfig
# PACKAGE-END
# PACKAGE-BEGIN
# PACKAGE-BEGIN

%package -n libgfortran%{libgfortran_sover}-32bit

Summary:        The GNU Fortran Compiler Runtime Library
License:        GPL-3.0-with-GCC-exception
Group:          Development/Languages/Fortran
%ifarch %quadmath_arch
Requires:       libquadmath%{libquadmath_sover}-32bit >= %{version}-%{release}
%endif
# Only one package may provide this - allows multiple gcc versions
# to co-exist without an overly large list of provides/obsoletes
Conflicts:      libgfortran%{libgfortran_sover}-32bit < %{version}-%{release}

%description -n libgfortran%{libgfortran_sover}-32bit
The runtime library needed to run programs compiled with the Fortran compiler
of the GNU Compiler Collection (GCC).

%post -n libgfortran%{libgfortran_sover}-32bit
/sbin/ldconfig

%postun -n libgfortran%{libgfortran_sover}-32bit
/sbin/ldconfig
# PACKAGE-END
# PACKAGE-BEGIN
# PACKAGE-BEGIN

%package -n libgfortran%{libgfortran_sover}-64bit

Summary:        The GNU Fortran Compiler Runtime Library
License:        GPL-3.0-with-GCC-exception
Group:          Development/Languages/Fortran
%ifarch %quadmath_arch
Requires:       libquadmath%{libquadmath_sover}-64bit >= %{version}-%{release}
%endif
# Only one package may provide this - allows multiple gcc versions
# to co-exist without an overly large list of provides/obsoletes
Conflicts:      libgfortran%{libgfortran_sover}-64bit < %{version}-%{release}

%description -n libgfortran%{libgfortran_sover}-64bit
The runtime library needed to run programs compiled with the Fortran compiler
of the GNU Compiler Collection (GCC).

%post -n libgfortran%{libgfortran_sover}-64bit
/sbin/ldconfig

%postun -n libgfortran%{libgfortran_sover}-64bit
/sbin/ldconfig
# PACKAGE-END

# PACKAGE-BEGIN
# PACKAGE-BEGIN

%package -n libquadmath%{libquadmath_sover}

Summary:        The GNU Fortran Compiler Quadmath Runtime Library
License:        LGPL-2.1
Group:          Development/Languages/Fortran
# Only one package may provide this - allows multiple gcc versions
# to co-exist without an overly large list of provides/obsoletes
Conflicts:      libquadmath%{libquadmath_sover} < %{version}-%{release}

%description -n libquadmath%{libquadmath_sover}
The runtime library needed to run programs compiled with the Fortran compiler
of the GNU Compiler Collection (GCC) and quadruple precision floating point
operations.

%post -n libquadmath%{libquadmath_sover}
/sbin/ldconfig

%postun -n libquadmath%{libquadmath_sover}
/sbin/ldconfig
# PACKAGE-END
# PACKAGE-BEGIN
# PACKAGE-BEGIN

%package -n libquadmath%{libquadmath_sover}-32bit

Summary:        The GNU Fortran Compiler Quadmath Runtime Library
License:        LGPL-2.1
Group:          Development/Languages/Fortran
# Only one package may provide this - allows multiple gcc versions
# to co-exist without an overly large list of provides/obsoletes
Conflicts:      libquadmath%{libquadmath_sover}-32bit < %{version}-%{release}

%description -n libquadmath%{libquadmath_sover}-32bit
The runtime library needed to run programs compiled with the Fortran compiler
of the GNU Compiler Collection (GCC) and quadruple precision floating point
operations.

%post -n libquadmath%{libquadmath_sover}-32bit
/sbin/ldconfig

%postun -n libquadmath%{libquadmath_sover}-32bit
/sbin/ldconfig
# PACKAGE-END
# PACKAGE-BEGIN
# PACKAGE-BEGIN

%package -n libquadmath%{libquadmath_sover}-64bit

Summary:        The GNU Fortran Compiler Quadmath Runtime Library
License:        LGPL-2.1
Group:          Development/Languages/Fortran
# Only one package may provide this - allows multiple gcc versions
# to co-exist without an overly large list of provides/obsoletes
Conflicts:      libquadmath%{libquadmath_sover}-64bit < %{version}-%{release}

%description -n libquadmath%{libquadmath_sover}-64bit
The runtime library needed to run programs compiled with the Fortran compiler
of the GNU Compiler Collection (GCC) and quadruple precision floating point
operations.

%post -n libquadmath%{libquadmath_sover}-64bit
/sbin/ldconfig

%postun -n libquadmath%{libquadmath_sover}-64bit
/sbin/ldconfig
# PACKAGE-END

# PACKAGE-BEGIN
# PACKAGE-BEGIN

%package -n libmudflap47
Summary:        The Mudflap Extension Runtime Library
License:        GPL-3.0-with-GCC-exception
Group:          Development/Languages/C and C++
Provides:       libmudflap%{libmudflap_sover} = %{version}-%{release}
Conflicts:      libmudflap%{libmudflap_sover} < %{version}-%{release}
Provides:       libmudflapth%{libmudflap_sover} = %{version}-%{release}
Conflicts:      libmudflapth%{libmudflap_sover} < %{version}-%{release}

%description -n libmudflap47
This is the Mudflap Extension Runtime Library.

%post -n libmudflap47
/sbin/ldconfig

%postun -n libmudflap47
/sbin/ldconfig
# PACKAGE-END
# PACKAGE-BEGIN
# PACKAGE-BEGIN

%package -n libmudflap47-32bit
Summary:        The Mudflap Extension Runtime Library
License:        GPL-3.0-with-GCC-exception
Group:          Development/Languages/C and C++
Provides:       libmudflap%{libmudflap_sover}-32bit = %{version}-%{release}
Conflicts:      libmudflap%{libmudflap_sover}-32bit < %{version}-%{release}
Provides:       libmudflapth%{libmudflap_sover}-32bit = %{version}-%{release}
Conflicts:      libmudflapth%{libmudflap_sover}-32bit < %{version}-%{release}

%description -n libmudflap47-32bit
This is the Mudflap Extension Runtime Library.

%post -n libmudflap47-32bit
/sbin/ldconfig

%postun -n libmudflap47-32bit
/sbin/ldconfig
# PACKAGE-END
# PACKAGE-BEGIN
# PACKAGE-BEGIN

%package -n libmudflap47-64bit
Summary:        The Mudflap Extension Runtime Library
License:        GPL-3.0-with-GCC-exception
Group:          Development/Languages/C and C++
Provides:       libmudflap%{libmudflap_sover}-64bit = %{version}-%{release}
Conflicts:      libmudflap%{libmudflap_sover}-64bit < %{version}-%{release}
Provides:       libmudflapth%{libmudflap_sover}-64bit = %{version}-%{release}
Conflicts:      libmudflapth%{libmudflap_sover}-64bit < %{version}-%{release}

%description -n libmudflap47-64bit
This is the Mudflap Extension Runtime Library.

%post -n libmudflap47-64bit
/sbin/ldconfig

%postun -n libmudflap47-64bit
/sbin/ldconfig
# PACKAGE-END

%package -n libgcj47
# LIBJAVA-DELETE-END
Summary:        Java Runtime Library for gcc
License:        GPL-2.0-with-classpath-exception
Group:          System/Libraries
%if 0%{suse_version} > 1000
Recommends:     libgcj47-jar = %{version}-%{release}
%endif
Provides:       libgcj%{gcj_sover} = %{version}-%{release}
Conflicts:      libgcj%{gcj_sover} < %{version}-%{release}
Provides:       libgij%{gcj_sover} = %{version}-%{release}
Conflicts:      libgij%{gcj_sover} < %{version}-%{release}
Provides:       libgcj-tools%{gcj_sover} = %{version}-%{release}
Conflicts:      libgcj-tools%{gcj_sover} < %{version}-%{release}

%description -n libgcj47
This library is needed if you want to use the GNU Java compiler, gcj.
Source code for this package is in gcc.

%post -n libgcj47
/sbin/ldconfig

%postun -n libgcj47
/sbin/ldconfig

%package -n gcc47-java
Summary:        The GNU Java Compiler
License:        GPL-3.0+
Group:          Development/Languages/Java
Requires:       gcc47 = %{version}
Requires:       libgcj47-devel = %{version}-%{release}

%description -n gcc47-java
The Java compiler from the GCC-tools-suite.


%package -n libgcj_bc%{libgcj_bc_sover}

Summary:        Fake library for BC-ABI compatibility.
License:        GPL-2.0-with-classpath-exception
Group:          Development/Libraries/Java
# libgcj_bc is special in that it just contains a symlink to
# a proper libgcj version.  So require that library and add
# provides for the shlib version as created at link time
Requires:       libgcj%{gcj_sover}
%ifarch x86_64 ia64 ppc64 s390x sparc64
Provides:       libgcj_bc.so.%{libgcj_bc_sover}()(64bit)
%else
Provides:       libgcj_bc.so.%{libgcj_bc_sover}
%endif
Conflicts:      libgcj_bc%{libgcj_bc_sover} < %{version}-%{release}

%description -n libgcj_bc%{libgcj_bc_sover}
A fake library that is used at link time only. It ensures that
binaries built with the BC-ABI link against a constant SONAME.
This way, BC-ABI binaries continue to work if the SONAME underlying
libgcj.so changes.


%package -n libgcj47-jar
Summary:        Java runtime library (jar files).
License:        GPL-2.0-with-classpath-exception
Group:          Development/Libraries/Java

%description -n libgcj47-jar
These are the jar files that go along with the gcj front end to gcc.


%package -n libgcj47-devel
Summary:        Include Files and Libraries mandatory for Development.
License:        GPL-2.0-with-classpath-exception
Group:          Development/Libraries/Java
Requires:       libstdc++47-devel = %{version}
Requires:       libgcj%{gcj_sover} >= %{version}-%{release}
Requires:       libgcj_bc%{libgcj_bc_sover} >= %{version}-%{release}
Requires:       libgcj47-jar = %{version}-%{release}
Requires:       gtk2-devel
Requires:       libart_lgpl-devel
Requires:       glibc-devel
Requires:       zlib-devel
%ifarch ia64
Requires:       libunwind-devel
%endif

%description -n libgcj47-devel
This package contains all necessary include files and libraries needed
to develop applications that require these.


%package -n gcc47-gij
Summary:        Java Bytecode Interpreter for gcc
License:        GPL-2.0-with-classpath-exception
Group:          Development/Libraries/Java
Requires:       libgcj%{gcj_sover} >= %{version}-%{release}

%description -n gcc47-gij
This package contains the java bytecode interpreter gij and related tools.

# LIBFFI-DELETE-END
# PACKAGE-BEGIN
# PACKAGE-BEGIN
%package -n libffi47
Summary:        Foreign Function Interface library
License:        BSD-3-Clause
Group:          Development/Languages/C and C++
Provides:       g-wrap:/usr/lib/libffi.so.4
Provides:       libffi4 = %{version}-%{release}
Conflicts:      libffi4 < %{version}-%{release}

%description -n libffi47
A foreign function interface is the popular name for the interface that allows code written in one language to call code written in another language.

%post -n libffi47
/sbin/ldconfig

%postun -n libffi47
/sbin/ldconfig
# PACKAGE-END
# PACKAGE-BEGIN
# PACKAGE-BEGIN

%package -n libffi47-32bit
Summary:        Foreign Function Interface library
License:        BSD-3-Clause
Group:          Development/Languages/C and C++
Provides:       g-wrap:/usr/lib/libffi.so.4
Provides:       libffi4-32bit = %{version}-%{release}
Conflicts:      libffi4-32bit < %{version}-%{release}

%description -n libffi47-32bit
A foreign function interface is the popular name for the interface that allows code written in one language to call code written in another language.

%post -n libffi47-32bit
/sbin/ldconfig

%postun -n libffi47-32bit
/sbin/ldconfig
# PACKAGE-END
# PACKAGE-BEGIN
# PACKAGE-BEGIN

%package -n libffi47-64bit
Summary:        Foreign Function Interface library
License:        BSD-3-Clause
Group:          Development/Languages/C and C++
Provides:       g-wrap:/usr/lib/libffi.so.4
Provides:       libffi4-64bit = %{version}-%{release}
Conflicts:      libffi4-64bit < %{version}-%{release}

%description -n libffi47-64bit
A foreign function interface is the popular name for the interface that allows code written in one language to call code written in another language.

%post -n libffi47-64bit
/sbin/ldconfig

%postun -n libffi47-64bit
/sbin/ldconfig
# PACKAGE-END

# PACKAGE-BEGIN
# PACKAGE-BEGIN

%package -n libffi47-devel
Summary:        Foreign Function Interface library development files
License:        BSD 3-Clause
Group:          Development/Languages/C and C++
Requires:       libffi%{libffi_sover} >= %{version}-%{release}
Provides:       libffi-devel = %{version}-%{release}
Conflicts:      libffi-devel < %{version}-%{release}

%description -n libffi47-devel
A foreign function interface is the popular name for the interface that allows code written in one language to call code written in another language.
# PACKAGE-END
# PACKAGE-BEGIN
# PACKAGE-BEGIN
%package -n libffi47-devel-32bit
Summary:        Foreign Function Interface library development files
License:        BSD 3-Clause
Group:          Development/Languages/C and C++
Requires:       libffi%{libffi_sover}-32bit >= %{version}-%{release}
Provides:       libffi-devel-32bit = %{version}-%{release}
Conflicts:      libffi-devel-32bit < %{version}-%{release}

%description -n libffi47-devel-32bit
A foreign function interface is the popular name for the interface that allows code written in one language to call code written in another language.
# PACKAGE-END
# PACKAGE-BEGIN
# PACKAGE-BEGIN
%package -n libffi47-devel-64bit
Summary:        Foreign Function Interface library development files
License:        BSD 3-Clause
Group:          Development/Languages/C and C++
Requires:       libffi%{libffi_sover}-64bit >= %{version}-%{release}
Provides:       libffi-devel-64bit = %{version}-%{release}
Conflicts:      libffi-devel-64bit < %{version}-%{release}

%description -n libffi47-devel-64bit
A foreign function interface is the popular name for the interface that allows code written in one language to call code written in another language.
# PACKAGE-END

%package -n gcc47-testresults
# GCC-TESTSUITE-DELETE-END
Summary:        Testsuite results
License:        SUSE-Public-Domain
Group:          Development/Languages/C and C++

%description -n gcc47-testresults
Results from running the gcc and target library testsuites.


# COMMON-BEGIN

# Define the canonical target and host architecture
#   %gcc_target_arch  is supposed to be the full target triple
#   %TARGET_ARCH      is the canonicalized CPU part
#   %CONFIGURE_TARGET is the target triple used for --target=
%if 0%{?gcc_target_arch:1}
%define CONFIGURE_TARGET %{gcc_target_arch}
%define TARGET_ARCH %(echo %{gcc_target_arch} | cut -d - -f 1 | sed -e "s/i.86/i586/;s/ppc/powerpc/;s/sparc64.*/sparc64/;s/sparcv.*/sparc/;")
%if 0%{?gcc_icecream:1} && %{TARGET_ARCH} == "powerpc"
%define CONFIGURE_TARGET powerpc64-suse-linux
%endif
%if 0%{?gcc_icecream:1} && %{TARGET_ARCH} == "powerpc64"
%define CONFIGURE_TARGET powerpc64-suse-linux
%endif
%if 0%{?gcc_icecream:1} && %{TARGET_ARCH} == "i586"
%define CONFIGURE_TARGET i586-suse-linux
%endif
%if 0%{?gcc_icecream:1} && %{TARGET_ARCH} == "armv7l"
%define CONFIGURE_TARGET armv7l-suse-linux-gnueabi
%endif
%if 0%{?gcc_icecream:1} && %{TARGET_ARCH} == "armv7hl"
%define CONFIGURE_TARGET armv7hl-suse-linux-gnueabi
%endif
%if 0%{?gcc_icecream:1} && %{TARGET_ARCH} == "armv5tel"
%define CONFIGURE_TARGET armv5tel-suse-linux-gnueabi
%endif
%else
%define TARGET_ARCH %(echo %{_target_cpu} | sed -e "s/i.86/i586/;s/ppc/powerpc/;s/sparc64.*/sparc64/;s/sparcv.*/sparc/;")
%endif
%define HOST_ARCH %(echo %{_host_cpu} | sed -e "s/i.86/i586/;s/ppc/powerpc/;s/sparc64.*/sparc64/;s/sparcv.*/sparc/;")

%define biarch %(case " %{biarch_targets} " in (*" %{TARGET_ARCH} "*) echo 1;; (*) echo 0;; esac)

%ifarch ppc
%define GCCDIST powerpc64-suse-linux
%else
%ifarch %sparc
%define GCCDIST sparc64-suse-linux
%else
%ifarch %arm
%define GCCDIST %{HOST_ARCH}-suse-linux-gnueabi
%else
%define GCCDIST %{HOST_ARCH}-suse-linux
%endif
%endif
%endif

%define libsubdir %{_libdir}/gcc/%{GCCDIST}/%{gcc_dir_version}
%define gxxinclude %{_prefix}/include/c++/%{gcc_dir_version}

# COMMON-END

# Versionspecific directories
%define versmainlibdir %{libsubdir}
%define versmainlibdirbi32 %{libsubdir}/32
%define versmainlibdirbi64 %{libsubdir}/64
%ifarch ppc
%define versnoflibdir %{libsubdir}/nof
%define versmainlibdirbi32 %{libsubdir}
%define versmainlibdirbi64 %{libsubdir}/64
%endif
%ifarch ppc64
%define versnoflibdir %{libsubdir}/32/nof
%endif
%if %{build_primary_64bit}
%define versmainlibdirbi %{versmainlibdirbi32}
%else
%define versmainlibdirbi %{versmainlibdirbi64}
%endif

%define mainlibdir %{_libdir}
%define mainlibdirbi32 %{_prefix}/lib
%define mainlibdirbi64 %{_prefix}/lib64
%define noflibdir %{_prefix}/lib/nof
%if %{build_primary_64bit}
%define mainlibdirbi %{mainlibdirbi32}
%else
%define mainlibdirbi %{mainlibdirbi64}
%endif

# Now define a few macros that make it easy to package libs and
# related files just to the right package, without caring for the
# exact path the files are in.
#   %mainlib  package X from all dirs that belong to the main package
#   %biarchlib   package X from all dirs that belong to the -32/64bit package
# by default, nof libs go where the 32bit libs go.
%if %{build_nof}
%define mainlib() %{mainlibdir}/%1\
%{noflibdir}/%1\
%{nil}
%else
%define mainlib() %{mainlibdir}/%1\
%{nil}
%endif
%define biarchlib() %{nil}
%if %{biarch}
%if !%{separate_biarch}
%if %{build_nof}
%define mainlib() %{mainlibdir}/%1\
%{mainlibdirbi}/%1\
%{noflibdir}/%1\
%{nil}
%else
%define mainlib() %{mainlibdir}/%1\
%{mainlibdirbi}/%1\
%{nil}
%endif
%else
%if %{build_nof}
%define biarchlib() %{mainlibdirbi}/%1\
%{noflibdir}/%1\
%{nil}
%define mainlib() %{mainlibdir}/%1\
%{nil}
%else
%define biarchlib() %{mainlibdirbi}/%1\
%{nil}
%endif
%endif
%endif

%if %{build_nof}
%define versmainlib() %{versmainlibdir}/%1\
%{versnoflibdir}/%1\
%{nil}
%else
%define versmainlib() %{versmainlibdir}/%1\
%{nil}
%endif
%define versbiarchlib() %{nil}
%if %{biarch}
%if !%{separate_biarch}
%if %{build_nof}
%define versmainlib() %{versmainlibdir}/%1\
%{versmainlibdirbi}/%1\
%{versnoflibdir}/%1\
%{nil}
%else
%define versmainlib() %{versmainlibdir}/%1\
%{versmainlibdirbi}/%1\
%{nil}
%endif
%else
%if %{build_nof}
%define versbiarchlib() %{versmainlibdirbi}/%1\
%{versnoflibdir}/%1\
%{nil}
%define versmainlib() %{versmainlibdir}/%1\
%{nil}
%else
%define versbiarchlib() %{versmainlibdirbi}/%1\
%{nil}
%endif
%endif
%endif

# COMMON-BEGIN

%prep
%setup -q -n gcc-%{gcc_version}%{snapshot_date}
%patch1
%patch2
%patch3
%patch6
%patch7
%patch8
%patch10
%if !%{build_nof}
%patch12
%endif
%patch23
%patch24
%patch30
%patch32
%patch33 -p1
%patch51
%patch55
%patch57
%patch60
%patch61
%patch130
%patch200
%patch201
# We are configuring ppc as ppc64 but with switched multilibs.  Adjust
# the libstdc++ abi testsuite baseline files accordingly
%ifarch ppc
if [ -d libstdc++-v3/config/abi/post/powerpc64-linux-gnu ]; then
  mkdir -p libstdc++-v3/config/abi/post/powerpc64-linux-gnu/64
  mv libstdc++-v3/config/abi/post/powerpc64-linux-gnu/baseline_symbols.txt \
	libstdc++-v3/config/abi/post/powerpc64-linux-gnu/64/
  mv libstdc++-v3/config/abi/post/powerpc64-linux-gnu/32/baseline_symbols.txt \
	libstdc++-v3/config/abi/post/powerpc64-linux-gnu/
fi
%endif

%build
# Avoid rebuilding of generated files
contrib/gcc_update --touch
# Avoid fucking up testsuite results with Java and indirect dispatch
export SUSE_ASNEEDED=0
# Split version file into version used for directories (X.Y) and
# version to report with --version (X.Y.Z).
# See also gcc-dir-version.patch.
# Also decrement the patchlevel version by one
if test `cat gcc/DEV-PHASE` == "prerelease"; then
  ( cat gcc/BASE-VER | cut -d '.' -f 1-2 | tr -d '\n'; echo -n .; cat gcc/BASE-VER | cut -d '.' -f 3 | tr '0123456789' '0012345678' ) > gcc/FULL-VER
else
  mv gcc/BASE-VER gcc/FULL-VER
fi
cat gcc/FULL-VER | cut -d '.' -f 1-2 > gcc/BASE-VER

rm -rf obj-%{GCCDIST}
mkdir obj-%{GCCDIST}
cd obj-%{GCCDIST}
RPM_OPT_FLAGS="$RPM_OPT_FLAGS -U_FORTIFY_SOURCE"
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-fno-rtti//g' -e 's/-fno-exceptions//g' -e 's/-Wmissing-format-attribute//g' -e 's/-fstack-protector//g' -e 's/-ffortify=.//g' -e 's/-Wall//g' -e 's/-m32//g' -e 's/-m64//g'`
%ifarch %ix86
# -mcpu is superceded by -mtune but -mtune is not supported by
# our bootstrap compiler.  -mcpu gives a warning that stops
# the build process, so remove it for now.  Also remove all other
# -march and -mtune flags.  They are superseeded by proper
# default compiler settings now.
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-mcpu=i.86//g' -e 's/-march=i.86//g' -e 's/-mtune=i.86//g'`
%endif
%ifarch s390 s390x
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-fsigned-char//g'`
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-O1/-O2/g'`
%endif
%if 0%{?gcc_target_arch:1} && 0%{!?gcc_icecream:1}
# Kill all -march/tune/cpu because that screws building the target libs
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-m\(arch\|tune\|cpu\)=[^ ]*//g'`
%endif
# Replace 2 spaces by one finally
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/  / /g'`

languages=c
%if %{build_cp}
languages=$languages,c++
%endif
%if %{build_objc}
languages=$languages,objc
%endif
%if %{build_fortran}
languages=$languages,fortran
%endif
%if %{build_objcp}
languages=$languages,obj-c++
%endif
%if %{build_java}
languages=$languages,java
%endif
%if %{build_ada}
languages=$languages,ada
%endif

J=%{?jobs:%jobs}
if test -z "$J"; then
  J=$(getconf _NPROCESSORS_CONF)
  JL=$(($J * 2))
else
  test 1 -gt "$J" && J=1
  JL=$(($(getconf _NPROCESSORS_CONF)*2))
fi
if test "$J" == "0"; then
  J=1
fi
if test "$JL" == "0"; then
  JL=1
fi
PARALLEL="-j$J -l$JL"

# we don't want some miscompiles in the testsuite, or some fault in
# the compiler to kill the machine.  Hence we limit the amount of memory
# by the physical RAM plus half of swap
#MEM=$(free -m | awk '/^Mem:/ {print $2}')
#SWAP=$(free -m | awk '/^Swap:/ {print $2}')
#ulimit -v $(((MEM + SWAP/2)*1024))

# In general we want to ship release checking enabled compilers
# and run BETA with checking enabled.
#ENABLE_CHECKING="--enable-checking=yes"
ENABLE_CHECKING="--enable-checking=release"

# Work around tail/head -1 changes
export _POSIX2_VERSION=199209

# configure tries to parse include/features.h to detect
# if glibc supports SSP.  When cross compiling we would need
# to install a cross glibc, which we don't, or make the whole
# thing point to the native glibc, which is in /, hence the
# --with-sysroot=/

%if %{build_ada}
# Using the host gnatmake like
#   CC="gcc%{hostsuffix}" GNATBIND="gnatbind%{hostsuffix}"
#   GNATMAKE="gnatmake%{hostsuffix}"
# doesn't work due to PR33857, so an un-suffixed gnatmake has to be
# available
mkdir -p host-tools/bin
cp -a /usr/bin/gnatmake%{hostsuffix} host-tools/bin/gnatmake
cp -a /usr/bin/gnatlink%{hostsuffix} host-tools/bin/gnatlink
cp -a /usr/bin/gnatbind%{hostsuffix} host-tools/bin/gnatbind
cp -a /usr/bin/gcc%{hostsuffix} host-tools/bin/gcc
ln -sf /usr/%{_lib} host-tools/%{_lib}
export PATH="`pwd`/host-tools/bin:$PATH"
%endif
#%if 0%{?gcc_target_arch:1} && 0%{!?gcc_icecream:1}
#%else
#	--enable-threads=posix \
#%endif
#	--enable-shared \
%if "%{TARGET_ARCH}" == "armv7l" || "%{TARGET_ARCH}" == "armv7hl"
# temporary workaround for a miscompilation of hash functions in java code
GCJ_EXTRA_FLAGS="-marm"
%endif
CFLAGS="$RPM_OPT_FLAGS" CXXFLAGS="$RPM_OPT_FLAGS" XCFLAGS="$RPM_OPT_FLAGS" \
TCFLAGS="$RPM_OPT_FLAGS" GCJFLAGS="$RPM_OPT_FLAGS $GCJ_EXTRA_FLAGS" \
../configure \
	--prefix=%{_prefix} \
	--infodir=%{_infodir} \
	--mandir=%{_mandir} \
	--libdir=%{_libdir} \
	--libexecdir=%{_libdir} \
	--enable-languages=$languages \
	$ENABLE_CHECKING \
	--with-gxx-include-dir=%{_prefix}/include/c++/%{gcc_dir_version} \
	--enable-ssp \
	--disable-libssp \
	--disable-libitm \
	--disable-plugin \
	--with-bugurl="http://bugs.opensuse.org/" \
	--with-pkgversion="SUSE Linux" \
%if !%{build_libjava}
        --disable-libgcj \
%else
	--with-java-home=%{_libdir}/jvm/java-1.5.0-gcj%{binsuffix}-1.5.0.0/jre \
	--with-ecj-jar=%{libsubdir}/ecj.jar \
        --disable-java-awt \
%if !%{biarch_libjava}
        --disable-libjava-multilib \
%endif
%endif
%if !%{build_with_mudflap}
	--disable-libmudflap \
%endif
	--with-slibdir=/%{_lib} \
	--with-system-zlib \
	--enable-__cxa_atexit \
	--enable-libstdcxx-allocator=new \
	--disable-libstdcxx-pch \
	--enable-version-specific-runtime-libs \
%if 0%{suse_version} > 1100
	--enable-linker-build-id \
%endif
	--disable-initfini-array \
%if 0%{?gcc_target_arch:1}
%if 0%{?gcc_icecream:1}
	--with-build-sysroot=/ \
	--with-sysroot=%{_prefix}/%{gcc_target_arch}%{?canonical_target_abi:%canonical_target_abi} \
	--with-gxx-include-dir=%{_prefix}/%{gcc_target_arch}%{?canonical_target_abi:%canonical_target_abi}/usr/include/c++/%{gcc_dir_version} \
	--enable-linux-futex \
%endif
%if 0%{?canonical_target:1}
	--with-build-time-tools=/usr/%{canonical_target}-suse-linux%{?canonical_target_abi:%canonical_target_abi}/bin \
%endif
%if 0%{?build_static:1}
	--disable-shared \
%endif
%if "%{TARGET_ARCH}" == "spu"
	--with-sysroot=/usr/spu \
	--with-gxx-include-dir=%{_prefix}/spu/include/c++/%{gcc_dir_version} \
	--with-newlib \
%endif
	--disable-nls \
	--target=%{CONFIGURE_TARGET} \
%else
	--program-suffix=%{binsuffix} \
	--enable-linux-futex \
%ifarch ia64
	--with-system-libunwind \
%else
	--without-system-libunwind \
%endif
%endif
%if "%{TARGET_ARCH}" == "armv5tel"
	--with-arch=armv5te \
	--with-float=soft \
	--with-mode=arm \
	--with-abi=aapcs-linux \
	--disable-sjlj-exceptions \
%endif
%if "%{TARGET_ARCH}" == "armv7l" || "%{TARGET_ARCH}" == "armv7hl"
	--with-arch=armv7-a \
	--with-tune=cortex-a9 \
	--with-float=hard \
	--with-abi=aapcs-linux \
	--with-fpu=vfpv3-d16 \
	--disable-sjlj-exceptions \
%endif
%if "%{TARGET_ARCH}" == "powerpc" || "%{TARGET_ARCH}" == "powerpc64"
%if "%{TARGET_ARCH}" == "powerpc"
	--with-cpu=default32 \
%endif
	--with-cpu-64=power4 \
	--enable-secureplt \
	--with-long-double-128 \
%endif
%if "%{TARGET_ARCH}" == "sparc64"
	--with-cpu=ultrasparc \
	--with-long-double-128 \
%endif
%if "%{TARGET_ARCH}" == "sparc"
	--with-cpu=v8 \
	--with-long-double-128 \
%endif
%if "%{TARGET_ARCH}" == "i586"
	--with-arch-32=i586 \
	--with-tune=generic \
%endif
%if "%{TARGET_ARCH}" == "x86_64"
	--with-arch-32=i586 \
	--with-tune=generic \
%endif
%if "%{TARGET_ARCH}" == "s390"
        --with-tune=z9-109 --with-arch=z900 \
	--with-long-double-128 \
	--enable-decimal-float \
%endif
%if "%{TARGET_ARCH}" == "s390x"
        --with-tune=z9-109 --with-arch=z900 \
	--with-long-double-128 \
	--enable-decimal-float \
%endif
	--build=%{GCCDIST}

# COMMON-END

%if 0%{?building_libffi:1}
make stage1-bubble $PARALLEL
make all-target-libffi $PARALLEL
%else
# Only run profiled bootstrap on archs where it works
#%ifarch %ix86 x86_64 ppc ppc64 ia64
#make profiledbootstrap-lean STAGE1_CFLAGS="-O -g" BOOT_CFLAGS="$RPM_OPT_FLAGS" $PARALLEL
#%else
%ifarch %arm
STAGE1_FLAGS="-O0"
%else
STAGE1_FLAGS="-O -g"
%endif
#make bootstrap-lean STAGE1_CFLAGS="$STAGE1_FLAGS" BOOT_CFLAGS="$RPM_OPT_FLAGS" $PARALLEL
make STAGE1_CFLAGS="$STAGE1_FLAGS" BOOT_CFLAGS="$RPM_OPT_FLAGS" $PARALLEL
#%endif
#make -C gcc proto
make info
%if 0%{?run_tests:1}
echo "Run testsuite"
(make -C %{GCCDIST}/libstdc++-v3 check-abi || true)
mv %{GCCDIST}/libstdc++-v3/testsuite/libstdc++.log %{GCCDIST}/libstdc++-v3/testsuite/libstdc++-abi.log
mv %{GCCDIST}/libstdc++-v3/testsuite/libstdc++.sum %{GCCDIST}/libstdc++-v3/testsuite/libstdc++-abi.sum
make -k check $PARALLEL || true
mkdir ../testresults
../contrib/test_summary | tee ../testresults/test_summary.txt
%endif
%endif

%install
export NO_BRP_CHECK_BYTECODE_VERSION=true
cd obj-%{GCCDIST}
# GCC-TESTSUITE-DELETE-BEGIN
# Work around tail/head -1 changes
export _POSIX2_VERSION=199209
export LIBRARY_PATH=$RPM_BUILD_ROOT%{libsubdir}:$RPM_BUILD_ROOT%{mainlibdirbi}
%if 0%{?building_libffi:1}
make -C %{GCCDIST}/libffi install DESTDIR=$RPM_BUILD_ROOT
%else
%if 0%{?building_libjava:1}
make -C %{GCCDIST}/libjava install DESTDIR=$RPM_BUILD_ROOT
make -C gcc java.install-man DESTDIR=$RPM_BUILD_ROOT
make -C gcc java.install-common DESTDIR=$RPM_BUILD_ROOT
make -C gcc install-common DESTDIR=$RPM_BUILD_ROOT COMPILERS='jc1$(exeext) jvgenmain$(exeext)'
# install-common also installs collect2, gcov and the g++ and gfortran driver
%if %{build_cp}
rm $RPM_BUILD_ROOT%{_prefix}/bin/g++%{binsuffix}
%endif
%if %{build_fortran}
rm $RPM_BUILD_ROOT%{_prefix}/bin/gfortran%{binsuffix}
%endif
rm $RPM_BUILD_ROOT%{_prefix}/bin/gcov%{binsuffix}
rm $RPM_BUILD_ROOT%{libsubdir}/collect2
%else
make install DESTDIR=$RPM_BUILD_ROOT
%if %{build_java}
make -C gcc java.uninstall DESTDIR=$RPM_BUILD_ROOT
make -C gcc java.install-info DESTDIR=$RPM_BUILD_ROOT
rm $RPM_BUILD_ROOT%{_prefix}/bin/jcf-dump%{binsuffix}
rm $RPM_BUILD_ROOT%{_mandir}/man1/jcf-dump%{binsuffix}.1
rm $RPM_BUILD_ROOT%{libsubdir}/jc1
rm $RPM_BUILD_ROOT%{libsubdir}/jvgenmain
%endif
%endif
%endif

# Remove libffi installed files if we did not want to build it
%if !0%{?building_libffi:1}
rm -f $RPM_BUILD_ROOT%{mainlibdir}/libffi.*
%if %{biarch}
  rm -f $RPM_BUILD_ROOT%{mainlibdirbi}/libffi.*
%endif
rm -f $RPM_BUILD_ROOT%{libsubdir}/include/ffi.h
rm -f $RPM_BUILD_ROOT%{libsubdir}/include/ffitarget.h
rm -f $RPM_BUILD_ROOT%{_mandir}/man3/ffi%{binsuffix}.3*
rm -f $RPM_BUILD_ROOT%{_mandir}/man3/ffi_call%{binsuffix}.3*
rm -f $RPM_BUILD_ROOT%{_mandir}/man3/ffi_prep_cif%{binsuffix}.3*
%endif

# Remove some useless .la files
for lib in libobjc libgfortran libgfortranbegin libquadmath libcaf_single \
    libmudflap libmudflapth libgomp libstdc++ libsupc++ libgcj-tools libgij; do
  rm -f $RPM_BUILD_ROOT%{versmainlibdir}/$lib.la
%if %{biarch}
  rm -f $RPM_BUILD_ROOT%{versmainlibdirbi}/$lib.la
%endif
done

mkdir -p $RPM_BUILD_ROOT%{_libdir}
%if %{biarch}
%if %{build_primary_64bit}
mkdir -p $RPM_BUILD_ROOT%{_prefix}/lib
%else
mkdir -p $RPM_BUILD_ROOT%{_prefix}/lib64
%endif
%endif

# LIBFFI-DELETE-BEGIN
# LIBJAVA-DELETE-BEGIN
%if %{build_cp}
# Merge multilib c++config.h to allow omitting the duplicate and
# identical other arch specific headers
dir_ml=
cxxconfig="`find %{GCCDIST}/libstdc++-v3/include -name c++config.h`"
for i in `find %{GCCDIST}/[36]*/libstdc++-v3/include -name c++config.h 2>/dev/null`; do
  if ! diff -up $cxxconfig $i; then
    file_32=x
    file_64=x
    case $i in
      %{GCCDIST}/32/*)
        file_32=$i
        file_64=$cxxconfig
        dir_ml=32
	;;
      %{GCCDIST}/64/*)
        file_32=$cxxconfig
	file_64=$i
        dir_ml=64
	;;
    esac
    if ! ( test -f "$file_32" && test -f "$file_64" ); then
      echo "Urgs?"
      exit 1
    fi

    cat > $RPM_BUILD_ROOT%{_prefix}/include/c++/%{gcc_dir_version}/%{GCCDIST}/bits/c++config.h <<EOF
#ifndef _CPP_CPPCONFIG_WRAPPER
#define _CPP_CPPCONFIG_WRAPPER 1
#include <bits/wordsize.h>
#if __WORDSIZE == 32
`cat $file_32`
#else
`cat $file_64`
#endif
#endif
EOF
    break
  fi
done
rm -rf $RPM_BUILD_ROOT%{_prefix}/include/c++/%{gcc_dir_version}/%{GCCDIST}/[36]*
if ! test -z "$dir_ml"; then
  ln -s . $RPM_BUILD_ROOT%{_prefix}/include/c++/%{gcc_dir_version}/%{GCCDIST}/$dir_ml
fi
%endif
# LIBJAVA-DELETE-END

# move shared libs from versionspecific dir to main libdir
for libname in \
%if 0%{?building_libjava:1}
  libgcj libgij libgcj-tools \
%else
%if %{build_fortran}
  libgfortran \
%ifarch %quadmath_arch
  libquadmath \
%endif
%endif
%if %{build_objc}
  libobjc \
%endif
%if %{build_cp}
  libstdc++ \
%endif
  libgomp \
%if %{build_with_mudflap}
  libmudflap libmudflapth \
%endif
%endif
    ; do
  for lib in `find $RPM_BUILD_ROOT%{versmainlibdir} -maxdepth 1 -name $libname.so.*`; do
    mv $lib $RPM_BUILD_ROOT%{mainlibdir}/
  done
  ln -sf %{mainlibdir}/`readlink $RPM_BUILD_ROOT%{versmainlibdir}/$libname.so | sed -e 's/\(.*\.so\.[^\.]*\).*/\1/'`  \
         $RPM_BUILD_ROOT%{versmainlibdir}/$libname.so
%if %{biarch}
  if test -d $RPM_BUILD_ROOT%{versmainlibdirbi}; then
    for lib in `find $RPM_BUILD_ROOT%{versmainlibdirbi} -maxdepth 1 -name "$libname.so.*"`; do
      mv $lib $RPM_BUILD_ROOT%{mainlibdirbi}/
    done
    ln -sf %{mainlibdirbi}/`readlink $RPM_BUILD_ROOT%{versmainlibdirbi}/$libname.so | sed -e 's/\(.*\.so\.[^\.]*\).*/\1/'`  \
         $RPM_BUILD_ROOT%{versmainlibdirbi}/$libname.so
  fi
%endif
done
%if %{build_cp}
%if !0%{?building_libjava:1}
# And we want to move the shlib gdb pretty printers to a more sane
# place so ldconfig does not complain
mkdir -p $RPM_BUILD_ROOT%{_datadir}/gdb/auto-load%{mainlibdir}
mv $RPM_BUILD_ROOT%{mainlibdir}/libstdc++.so.*-gdb.py $RPM_BUILD_ROOT%{_datadir}/gdb/auto-load%{mainlibdir}/
sed -i -e '/^libdir/s/\/gcc\/%{GCCDIST}\/%{gcc_dir_version}//g' $RPM_BUILD_ROOT%{_datadir}/gdb/auto-load%{mainlibdir}/libstdc++.so.*-gdb.py
%if %{biarch}
  if test -d $RPM_BUILD_ROOT%{versmainlibdirbi}; then
    mkdir -p $RPM_BUILD_ROOT%{_datadir}/gdb/auto-load%{mainlibdirbi}
    mv $RPM_BUILD_ROOT%{mainlibdirbi}/libstdc++.so.*-gdb.py $RPM_BUILD_ROOT%{_datadir}/gdb/auto-load%{mainlibdirbi}/
    sed -i -e '/^libdir/s/\/gcc\/%{GCCDIST}\/%{gcc_dir_version}//g' $RPM_BUILD_ROOT%{_datadir}/gdb/auto-load%{mainlibdirbi}/libstdc++.so.*-gdb.py
  fi
%endif
%endif
%endif
%if 0%{?building_libjava:1}
# libgcj_bc is special as the .so file is actually a different
# library as the library refered to by the SONAME which should
# be a simple link to our libgcj.
for lib in `find $RPM_BUILD_ROOT%{versmainlibdir} -maxdepth 1 -name libgcj_bc.so.*`; do
  rm $lib
done
ln -s libgcj.so.%{gcj_sover} $RPM_BUILD_ROOT%{mainlibdir}/libgcj_bc.so.%{libgcj_bc_sover}
%if %{biarch_libjava}
for lib in `find $RPM_BUILD_ROOT%{versmainlibdirbi} -maxdepth 1 -name libgcj_bc.so.*`; do
  rm $lib
done
ln -s libgcj.so.%{gcj_sover} $RPM_BUILD_ROOT%{mainlibdirbi}/libgcj_bc.so.%{libgcj_bc_sover}
%endif
%endif

# LIBJAVA-DELETE-BEGIN
# Move libgcc_s around
if test -L $RPM_BUILD_ROOT/%{_lib}/libgcc_s.so; then
  rm -f $RPM_BUILD_ROOT/%{_lib}/libgcc_s.so
  ln -sf /%{_lib}/libgcc_s.so.%{libgcc_s} $RPM_BUILD_ROOT%{versmainlibdir}/libgcc_s.so
else
  mv $RPM_BUILD_ROOT/%{_lib}/libgcc_s.so $RPM_BUILD_ROOT%{versmainlibdir}/
fi
chmod a+x $RPM_BUILD_ROOT/%{_lib}/libgcc_s.so.%{libgcc_s}
%if %{biarch}
%if %{build_primary_64bit}
if test -L $RPM_BUILD_ROOT/lib/libgcc_s.so; then
  rm -f $RPM_BUILD_ROOT/lib/libgcc_s.so
  ln -sf /lib/libgcc_s.so.%{libgcc_s} $RPM_BUILD_ROOT%{versmainlibdirbi32}/libgcc_s.so
else
  mv $RPM_BUILD_ROOT/lib/libgcc_s.so $RPM_BUILD_ROOT%{versmainlibdirbi32}/
fi
ln -sf %{versmainlibdirbi32}/libgcc_s.so $RPM_BUILD_ROOT%{versmainlibdirbi32}/libgcc_s_32.so
chmod a+x $RPM_BUILD_ROOT/lib/libgcc_s.so.%{libgcc_s}
%else
# 32-bit biarch systems
if test -L $RPM_BUILD_ROOT/lib64/libgcc_s.so; then
  rm -f $RPM_BUILD_ROOT/lib64/libgcc_s.so
  ln -sf /lib64/libgcc_s.so.%{libgcc_s} $RPM_BUILD_ROOT%{versmainlibdirbi64}/libgcc_s.so
else
  mv $RPM_BUILD_ROOT/lib64/libgcc_s.so $RPM_BUILD_ROOT%{versmainlibdirbi64}/
fi
ln -sf %{versmainlibdirbi64}/libgcc_s.so $RPM_BUILD_ROOT%{versmainlibdirbi64}/libgcc_s_64.so
chmod a+x $RPM_BUILD_ROOT/lib64/libgcc_s.so.%{libgcc_s}
%endif
%endif

# LIBJAVA-DELETE-END
# LIBFFI-DELETE-END

%if %{build_ada}
mv $RPM_BUILD_ROOT%{libsubdir}/adalib/lib*-*.so $RPM_BUILD_ROOT%{_libdir}
ln -sf %{_libdir}/libgnarl%{binsuffix}.so $RPM_BUILD_ROOT%{libsubdir}/adalib/libgnarl.so
ln -sf %{_libdir}/libgnat%{binsuffix}.so $RPM_BUILD_ROOT%{libsubdir}/adalib/libgnat.so
chmod a+x $RPM_BUILD_ROOT%{_libdir}/libgna*-*.so
%if %{biarch}
mv $RPM_BUILD_ROOT%{versmainlibdirbi}/adalib/lib*-*.so $RPM_BUILD_ROOT%{mainlibdirbi}/
ln -sf %{mainlibdirbi}/libgnarl%{binsuffix}.so $RPM_BUILD_ROOT%{versmainlibdirbi}/adalib/libgnarl.so
ln -sf %{mainlibdirbi}/libgnat%{binsuffix}.so $RPM_BUILD_ROOT%{versmainlibdirbi}/adalib/libgnarl.so
chmod a+x $RPM_BUILD_ROOT%{mainlibdirbi}/libgna*-*.so
%endif
%endif

rm -f $RPM_BUILD_ROOT%{_prefix}/bin/c++%{binsuffix}

# Remove some crap from the .la files:
for l in `find $RPM_BUILD_ROOT -name '*.la'`; do
  echo "changing $l"
# -e '/^dependency_libs/s|%{libsubdir}/\([^.]*\)\.la |%{_libdir}/\1\.la |g'
  sed -e '/^dependency_libs/s| -L%{_builddir}/[^ ]*||g' \
      -e '/^dependency_libs/s| -L/usr/%{GCCDIST}/bin||g' \
      -e '/^dependency_libs/s|-lm \(-lm \)*|-lm |' \
      -e '/^dependency_libs/s|-L[^ ]* ||g' \
%if %{biarch}
%if %{build_primary_64bit}
      -e '/^libdir/s|%{_libdir}/32|%{_prefix}/lib|' \
      -e '/^libdir/s|lib64/\.\./||' \
%else
      -e '/^libdir/s|%{_libdir}/64|%{_prefix}/lib64|' \
%endif
%endif
      < $l  > $l.new
  mv $l.new $l
done

# GCC-TESTSUITE-DELETE-END
%if 0%{?run_tests:1} 
cp `find . -name "*.sum"` ../testresults/
cp `find . -name "*.log"  \! -name "config.log" | grep -v 'acats.\?/tests' ` ../testresults/
chmod 644 ../testresults/*
%endif
# GCC-TESTSUITE-DELETE-BEGIN
# LIBFFI-DELETE-BEGIN
%if %{build_cp}
# Find C++ and Java headers
find $RPM_BUILD_ROOT%{_prefix}/include/c++ \
  -regex ".*/\(org\|gcj\|gnu\|java\|javax\)" -prune \
  -o \( -type d -printf "%%%%dir " , \
        -printf "%{_prefix}/include/c++/%%P\n" \) > ../c++-headers
%endif
# LIBFFI-DELETE-END
# Remove files that we do not need to clean up filelist
rm -f $RPM_BUILD_ROOT%{_prefix}/bin/%{GCCDIST}-*
rm -rf $RPM_BUILD_ROOT%{libsubdir}/install-tools
#rm -rf $RPM_BUILD_ROOT%{_libdir}/pkgconfig/libgcj%{binsuffix}.pc
rm -rf $RPM_BUILD_ROOT%{libsubdir}/include-fixed/root
rm -f $RPM_BUILD_ROOT%{libsubdir}/include-fixed/curses.h
rm -rf $RPM_BUILD_ROOT%{libsubdir}/include-fixed/asm-*
rm -rf $RPM_BUILD_ROOT%{libsubdir}/include-fixed/linux
rm -rf $RPM_BUILD_ROOT%{libsubdir}/include-fixed/sound
rm -rf $RPM_BUILD_ROOT%{libsubdir}/include-fixed/features.h
rm -f $RPM_BUILD_ROOT%{libsubdir}/include-fixed/ncurses.h
rm -f $RPM_BUILD_ROOT%{libsubdir}/include-fixed/stdio.h
rm -f $RPM_BUILD_ROOT%{libsubdir}/include-fixed/zutil.h
rm -rf $RPM_BUILD_ROOT%{libsubdir}/include-fixed/X11
rm -rf $RPM_BUILD_ROOT%{libsubdir}/include-fixed/bits
rm -f $RPM_BUILD_ROOT%{libsubdir}/include-fixed/obstack.h
rm -f $RPM_BUILD_ROOT%{libsubdir}/include-fixed/spe.h
rm -f $RPM_BUILD_ROOT%{libsubdir}/include-fixed/tgmath.h
rm -rf $RPM_BUILD_ROOT%{libsubdir}/include-fixed/bits
rm -rf $RPM_BUILD_ROOT%{libsubdir}/include-fixed/sys
# no plugins
rm -rf $RPM_BUILD_ROOT%{libsubdir}/plugin
rm -f  $RPM_BUILD_ROOT%{_infodir}/dir
rm -f  $RPM_BUILD_ROOT%{_prefix}/bin/gccbug%{binsuffix}

%if !0%{?building_libjava:1}%{?building_libffi:1}
# delete compile flag tracking from crt files
crt_list=$RPM_BUILD_ROOT%{versmainlibdir}/crt*.o
%if %{biarch}
%if %{build_primary_64bit}
crt32_list=$RPM_BUILD_ROOT%{versmainlibdirbi32}/crt*.o
%else
crt64_list=$RPM_BUILD_ROOT%{versmainlibdirbi64}/crt*.o
%endif
%endif
for o in $crt_list $crt32_list $crt64_list; do
  objcopy -R ".comment.SUSE.OPTs" $o
done
%endif

%if 0%{?building_libjava:1}
# gcj -static doesn't work properly anyway, unless using --whole-archive
# let's save the space instead.
find $RPM_BUILD_ROOT -name libgcj.a \
	-o -name libgcj-tools.a \
	-o -name libgij.a \
	-o -name libjvm.a \
	-o -name libgcj_bc.a \
  | xargs rm -f

find $RPM_BUILD_ROOT -name libgcj.spec | xargs \
  sed -i -e 's/lib: /&%%{static:%%eJava programs cannot be linked statically}/'

# security files have broken install locations, also they cause conflicts
# between libgcj versions.  Simply delete them here, libgcj will use its
# defaults in this case (which is what these files contain anyway).
rm $RPM_BUILD_ROOT%{_libdir}/logging.properties
rm -r $RPM_BUILD_ROOT%{_libdir}/security
%endif

%if 0%{?building_libffi:1}
# Move libffi headers, remove empty libffi libtool file
mkdir -p $RPM_BUILD_ROOT%{_prefix}/include
mv $RPM_BUILD_ROOT%{libsubdir}/include/ffitarget.h $RPM_BUILD_ROOT%{_prefix}/include/
mv $RPM_BUILD_ROOT%{libsubdir}/include/ffi.h $RPM_BUILD_ROOT%{_prefix}/include/
rm -f $RPM_BUILD_ROOT%{mainlibdir}/libffi.la
%if %{biarch}
rm -f $RPM_BUILD_ROOT%{mainlibdirbi}/libffi.la
%endif
# Generate a simple pkg-config file
mkdir -p $RPM_BUILD_ROOT%{_libdir}/pkgconfig
echo -e 'Name: libffi\nVersion: 3.0.9\nDescription: libffi\nLibs: -lffi' > $RPM_BUILD_ROOT%{_libdir}/pkgconfig/libffi.pc
%endif

%if %{build_java}
%if !%{build_libjava}
rm $RPM_BUILD_ROOT%{_mandir}/man1/jv-convert%{binsuffix}.1
rm $RPM_BUILD_ROOT%{_mandir}/man1/gcj-dbtool%{binsuffix}.1
rm $RPM_BUILD_ROOT%{_mandir}/man1/gij%{binsuffix}.1
rm $RPM_BUILD_ROOT%{_mandir}/man1/grmic%{binsuffix}.1
rm $RPM_BUILD_ROOT%{_mandir}/man1/gc-analyze%{binsuffix}.1
rm $RPM_BUILD_ROOT%{_mandir}/man1/aot-compile%{binsuffix}.1
rm $RPM_BUILD_ROOT%{_mandir}/man1/rebuild-gcj-db%{binsuffix}.1
%endif
rm -f $RPM_BUILD_ROOT%{_datadir}/gcc%{binsuffix}/python/libjava/aotcompile.py
rm -f $RPM_BUILD_ROOT%{_datadir}/gcc%{binsuffix}/python/libjava/classfile.py
%endif
rm -f $RPM_BUILD_ROOT%{_mandir}/man7/fsf-funding.7
rm -f $RPM_BUILD_ROOT%{_mandir}/man7/gfdl.7
rm -f $RPM_BUILD_ROOT%{_mandir}/man7/gpl.7
rm -f $RPM_BUILD_ROOT%{_libdir}/libiberty.a
%if %{build_nof}
rm -f $RPM_BUILD_ROOT%{_prefix}/lib/nof/libiberty.a
%endif
%if %{biarch}
%if %{build_primary_64bit}
rm -f $RPM_BUILD_ROOT%{_prefix}/lib/libiberty.a
%else
rm -f $RPM_BUILD_ROOT%{_prefix}/lib64/libiberty.a
%endif
%endif
rm -f $RPM_BUILD_ROOT%{libsubdir}/liblto_plugin.a
rm -f $RPM_BUILD_ROOT%{libsubdir}/liblto_plugin.la

# LIBFFI-DELETE-BEGIN
%if 0%{?building_libjava:1}
# For building libjava only we need to delete other info docs
rm $RPM_BUILD_ROOT%{_infodir}/cp-tools.info*
# Remove stale manpages for binaries we do not build
rm $RPM_BUILD_ROOT%{_mandir}/man1/gjdoc%{binsuffix}.1
# For building the java frontend we need to copy the ecj jar
mkdir -p $RPM_BUILD_ROOT%{libsubdir}
cp $RPM_SOURCE_DIR/ecj.jar $RPM_BUILD_ROOT%{libsubdir}
%else
# For regular build, some info files do not get renamed properly.
# Do so here.
mv $RPM_BUILD_ROOT%{_infodir}/libgomp.info $RPM_BUILD_ROOT%{_infodir}/libgomp%{binsuffix}.info
%if %{build_fortran} 
%ifarch %quadmath_arch
mv $RPM_BUILD_ROOT%{_infodir}/libquadmath.info $RPM_BUILD_ROOT%{_infodir}/libquadmath%{binsuffix}.info
%endif
%endif
%if %{build_ada}
mv $RPM_BUILD_ROOT%{_infodir}/gnat-style.info $RPM_BUILD_ROOT%{_infodir}/gnat-style%{binsuffix}.info
mv $RPM_BUILD_ROOT%{_infodir}/gnat_rm.info $RPM_BUILD_ROOT%{_infodir}/gnat_rm%{binsuffix}.info
mv $RPM_BUILD_ROOT%{_infodir}/gnat_ugn.info $RPM_BUILD_ROOT%{_infodir}/gnat_ugn%{binsuffix}.info
%endif
%endif

# LIBJAVA-DELETE-BEGIN
cd ..
%if 0%{suse_version} > 1000
%find_lang gcc47-locale --all-name
%else
%find_lang cpplib%{binsuffix}
%find_lang gcc%{binsuffix}
%find_lang libstdc++
cat cpplib%{binsuffix}.lang gcc%{binsuffix}.lang libstdc++.lang \
       > gcc47-locale.lang
%endif

%post info
%install_info --info-dir=%{_infodir} %{_infodir}/cpp%{binsuffix}.info.gz
%install_info --info-dir=%{_infodir} %{_infodir}/cppinternals%{binsuffix}.info.gz
%install_info --info-dir=%{_infodir} %{_infodir}/gcc%{binsuffix}.info.gz
%install_info --info-dir=%{_infodir} %{_infodir}/gccint%{binsuffix}.info.gz
%install_info --info-dir=%{_infodir} %{_infodir}/gccinstall%{binsuffix}.info.gz
%install_info --info-dir=%{_infodir} %{_infodir}/libgomp%{binsuffix}.info.gz
%if %{build_fortran} 
%install_info --info-dir=%{_infodir} %{_infodir}/gfortran%{binsuffix}.info.gz
%ifarch %quadmath_arch
%install_info --info-dir=%{_infodir} %{_infodir}/libquadmath%{binsuffix}.info.gz
%endif
%endif
%if %{build_java}
%install_info --info-dir=%{_infodir} %{_infodir}/gcj%{binsuffix}.info.gz
%endif
%if %{build_ada}
%install_info --info-dir=%{_infodir} %{_infodir}/gnat-style%{binsuffix}.info.gz
%install_info --info-dir=%{_infodir} %{_infodir}/gnat_rm%{binsuffix}.info.gz
%install_info --info-dir=%{_infodir} --section="GNU Ada tools" --entry="* GNAT User's Guide: (gnat_ugn). GNAT User's Guide for Unix Platforms" %{_infodir}/gnat_ugn%{binsuffix}.info.gz
%endif

%postun info
%install_info_delete --info-dir=%{_infodir} %{_infodir}/cpp%{binsuffix}.info.gz
%install_info_delete --info-dir=%{_infodir} %{_infodir}/cppinternals%{binsuffix}.info.gz
%install_info_delete --info-dir=%{_infodir} %{_infodir}/gcc%{binsuffix}.info.gz
%install_info_delete --info-dir=%{_infodir} %{_infodir}/gccint%{binsuffix}.info.gz
%install_info_delete --info-dir=%{_infodir} %{_infodir}/gccinstall%{binsuffix}.info.gz
%install_info_delete --info-dir=%{_infodir} %{_infodir}/libgomp%{binsuffix}.info.gz
%if %{build_fortran}
%install_info_delete --info-dir=%{_infodir} %{_infodir}/gfortran%{binsuffix}.info.gz
%ifarch %quadmath_arch
%install_info_delete --info-dir=%{_infodir} %{_infodir}/libquadmath%{binsuffix}.info.gz
%endif
%endif
%if %{build_java}
%install_info_delete --info-dir=%{_infodir} %{_infodir}/gcj%{binsuffix}.info.gz
%endif
%if %{build_ada}
%install_info_delete --info-dir=%{_infodir} %{_infodir}/gnat-style%{binsuffix}.info.gz
%install_info_delete --info-dir=%{_infodir} %{_infodir}/gnat_rm%{binsuffix}.info.gz
%install_info_delete --info-dir=%{_infodir} %{_infodir}/gnat_ugn%{binsuffix}.info.gz
%endif

%files
%defattr(-,root,root)
%dir %{_libdir}/gcc
%dir %{_libdir}/gcc/%{GCCDIST}
%dir %{libsubdir}
%dir %{libsubdir}/include
%dir %{libsubdir}/include-fixed
%if %{biarch}
%if %{build_primary_64bit}
%dir %{libsubdir}/32
%else
%dir %{libsubdir}/64
%endif
%endif
%if %{build_nof}
%dir %{libsubdir}/nof
%endif
%{_prefix}/bin/gcc%{binsuffix}
%{_prefix}/bin/gcov%{binsuffix}
%{_prefix}/bin/gcc-ar%{binsuffix}
%{_prefix}/bin/gcc-nm%{binsuffix}
%{_prefix}/bin/gcc-ranlib%{binsuffix}
%{libsubdir}/collect2
%{libsubdir}/lto1
%{libsubdir}/lto-wrapper
%{libsubdir}/liblto_plugin.so*
%{libsubdir}/include-fixed/README
%{libsubdir}/include-fixed/limits.h
%{libsubdir}/include-fixed/syslimits.h
%if %{suse_version} < 1030
%{libsubdir}/include-fixed/wchar.h
%endif
%{libsubdir}/include/omp.h
%{libsubdir}/include/float.h
%{libsubdir}/include/iso646.h
%{libsubdir}/include/stdarg.h
%{libsubdir}/include/stdbool.h
%{libsubdir}/include/stdfix.h
%{libsubdir}/include/stddef.h
%{libsubdir}/include/uchar.h
%{libsubdir}/include/unwind.h
%{libsubdir}/include/varargs.h
%{libsubdir}/include/stdint.h
%{libsubdir}/include/stdint-gcc.h
%{libsubdir}/include/stdnoreturn.h
%{libsubdir}/include/stdalign.h
%ifarch %sparc
%{libsubdir}/include/visintrin.h
%endif
%ifarch ppc ppc64
%{libsubdir}/include/altivec.h
%{libsubdir}/include/ppc-asm.h
%{libsubdir}/include/paired.h
%{libsubdir}/include/ppu_intrinsics.h
%{libsubdir}/include/si2vmx.h
%{libsubdir}/include/spe.h
%{libsubdir}/include/spu2vmx.h
%{libsubdir}/include/vec_types.h
%endif
%ifarch ia64
%{libsubdir}/include/ia64intrin.h
%endif
%ifarch %arm
%{libsubdir}/include/mmintrin.h
%{libsubdir}/include/arm_neon.h
%{libsubdir}/include/unwind-arm-common.h
%endif
%ifarch %ix86 x86_64
%{libsubdir}/include/cross-stdarg.h
%{libsubdir}/include/cpuid.h
%{libsubdir}/include/mm3dnow.h
%{libsubdir}/include/mmintrin.h
%{libsubdir}/include/ammintrin.h
%{libsubdir}/include/bmmintrin.h
%{libsubdir}/include/emmintrin.h
%{libsubdir}/include/immintrin.h
%{libsubdir}/include/avxintrin.h
%{libsubdir}/include/pmmintrin.h
%{libsubdir}/include/xmmintrin.h
%{libsubdir}/include/tmmintrin.h
%{libsubdir}/include/nmmintrin.h
%{libsubdir}/include/smmintrin.h
%{libsubdir}/include/wmmintrin.h
%{libsubdir}/include/x86intrin.h
%{libsubdir}/include/ia32intrin.h
%{libsubdir}/include/mm_malloc.h
%{libsubdir}/include/fma4intrin.h
%{libsubdir}/include/xopintrin.h
%{libsubdir}/include/lwpintrin.h
%{libsubdir}/include/popcntintrin.h
%{libsubdir}/include/bmiintrin.h
%{libsubdir}/include/tbmintrin.h
%{libsubdir}/include/avx2intrin.h
%{libsubdir}/include/bmi2intrin.h
%{libsubdir}/include/fmaintrin.h
%{libsubdir}/include/lzcntintrin.h
%{libsubdir}/include/f16cintrin.h
%endif
%if %{build_with_mudflap}
%{libsubdir}/include/mf-runtime.h
%endif
%versmainlib *crt*.o

%versmainlib libgcc*.a

%versmainlib libgcov.a

%versmainlib libgcc_s*.so

%if %{build_with_mudflap}
%versmainlib libmudflap.a

%versmainlib libmudflap.so

%versmainlib libmudflapth.a

%versmainlib libmudflapth.so

%endif
%versmainlib libgomp.so

%versmainlib libgomp.a

%versmainlib libgomp.spec

%doc %{_mandir}/man1/gcc%{binsuffix}.1.gz
%doc %{_mandir}/man1/gcov%{binsuffix}.1.gz

%if %{separate_biarch}

%files -n gcc47%{separate_biarch_suffix}
%defattr(-,root,root)
%versbiarchlib *crt*.o

%versbiarchlib libgcc*.a

%versbiarchlib libgcov.a

%versbiarchlib libgcc_s*.so

%if %{build_with_mudflap}
%versbiarchlib libmudflap.a

%versbiarchlib libmudflap.so

%versbiarchlib libmudflapth.a

%versbiarchlib libmudflapth.so

%endif
%versbiarchlib libgomp.so

%versbiarchlib libgomp.a

%versbiarchlib libgomp.spec

%endif

%files locale -f gcc47-locale.lang

%if %{build_cp}

%files c++
%defattr(-,root,root)
%dir %{_libdir}/gcc
%dir %{_libdir}/gcc/%{GCCDIST}
%dir %{libsubdir}
%{_prefix}/bin/g++%{binsuffix}
%doc %{_mandir}/man1/g++%{binsuffix}.1.gz
%{libsubdir}/cc1plus

%files -n libstdc++%{libstdcxx_sover}
%defattr(-,root,root)
%if %{build_nof}
%dir %{noflibdir}
%endif
%mainlib libstdc++.so.%{libstdcxx_sover}*


%if %{separate_biarch}

%files -n libstdc++%{libstdcxx_sover}%{separate_biarch_suffix}
%defattr(-,root,root)
%biarchlib libstdc++.so.%{libstdcxx_sover}*

%endif

%files -n libstdc++47-devel -f c++-headers
%defattr(-,root,root)
%versmainlib libstdc++.a

%versmainlib libstdc++.so

%versmainlib libsupc++.a

%dir %{_datadir}/gdb
%dir %{_datadir}/gdb/auto-load
%dir %{_datadir}/gdb/auto-load%{_prefix}
%dir %{_datadir}/gdb/auto-load/%{mainlibdir}
%{_datadir}/gdb/auto-load/%{mainlibdir}/libstdc++.so.*-gdb.py
%{_datadir}/gcc%{binsuffix}

%if %{separate_biarch}

%files -n libstdc++47-devel%{separate_biarch_suffix}
%defattr(-,root,root)
%versbiarchlib libstdc++.a

%versbiarchlib libstdc++.so

%versbiarchlib libsupc++.a

%dir %{_datadir}/gdb/auto-load/%{mainlibdirbi}
%{_datadir}/gdb/auto-load/%{mainlibdirbi}/libstdc++.so.*-gdb.py
%endif

%files -n libstdc++47-doc
%defattr(-,root,root)
%doc libstdc++-v3/doc/html
%endif

%files -n libgcc_s%{libgcc_s}
%defattr(-,root,root)
/%{_lib}/libgcc_s.so.%{libgcc_s}
%if %{build_nof}
%dir /lib/nof
/lib/nof/libgcc_s.so.%{libgcc_s}
%endif
%if %{biarch}
%if %{build_primary_64bit}
%if !%{separate_bi32}
/lib/libgcc_s.so.%{libgcc_s}
%endif
%else
%if !%{separate_bi64}
/lib64/libgcc_s.so.%{libgcc_s}
%endif
%endif
%endif

%if %{separate_bi64}

%files -n libgcc_s%{libgcc_s}-64bit
%defattr(-,root,root)
/lib64/libgcc_s.so.%{libgcc_s}
%endif

%if %{separate_bi32}

%files -n libgcc_s%{libgcc_s}-32bit
%defattr(-,root,root)
/lib/libgcc_s.so.%{libgcc_s}
%endif

%files -n libgomp%{libgomp_sover}
%defattr(-,root,root)
%mainlib libgomp.so.%{libgomp_sover}*


%if %{separate_biarch}

%files -n libgomp%{libgomp_sover}%{separate_biarch_suffix}
%defattr(-,root,root)
%biarchlib libgomp.so.%{libgomp_sover}*

%endif

%if %{build_fortran}

%files fortran
%defattr(-,root,root)
%dir %{libsubdir}/finclude
%{_prefix}/bin/gfortran%{binsuffix}
%{libsubdir}/f951
%{libsubdir}/finclude/*
%versmainlib libgfortran.a

%versmainlib libgfortran.so

%versmainlib libgfortran.spec

%versmainlib libgfortranbegin.a

%versmainlib libcaf_single.a

%ifarch %quadmath_arch
%{libsubdir}/include/quadmath.h
%{libsubdir}/include/quadmath_weak.h
%versmainlib libquadmath.a

%versmainlib libquadmath.so

%endif
%doc %{_mandir}/man1/gfortran%{binsuffix}.1.gz

%if %{separate_biarch}

%files fortran%{separate_biarch_suffix}
%defattr(-,root,root)
%versbiarchlib libgfortran.a

%versbiarchlib libgfortran.so

%versbiarchlib libgfortran.spec

%versbiarchlib libgfortranbegin.a

%versbiarchlib libcaf_single.a

%ifarch %quadmath_arch
%versbiarchlib libquadmath.a

%versbiarchlib libquadmath.so

%endif
%endif

%files -n libgfortran%{libgfortran_sover}
%defattr(-,root,root)
%mainlib libgfortran.so.%{libgfortran_sover}*


%if %{separate_biarch}

%files -n libgfortran%{libgfortran_sover}%{separate_biarch_suffix}
%defattr(-,root,root)
%biarchlib libgfortran.so.%{libgfortran_sover}*

%endif

%ifarch %quadmath_arch

%files -n libquadmath%{libquadmath_sover}
%defattr(-,root,root)
%mainlib libquadmath.so.%{libquadmath_sover}*


%if %{separate_biarch}

%files -n libquadmath%{libquadmath_sover}%{separate_biarch_suffix}
%defattr(-,root,root)
%biarchlib libquadmath.so.%{libquadmath_sover}*

%endif
%endif
%endif

%if %{build_with_mudflap}

%files -n libmudflap47
%defattr(-,root,root)
%mainlib libmudflap.so.%{libmudflap_sover}*

%mainlib libmudflapth.so.%{libmudflap_sover}*


%if %{separate_biarch}

%files -n libmudflap47%{separate_biarch_suffix}
%defattr(-,root,root)
%biarchlib libmudflap.so.%{libmudflap_sover}*

%biarchlib libmudflapth.so.%{libmudflap_sover}*

%endif
%endif

%files info
%defattr(-,root,root)
%doc %{_infodir}/cpp%{binsuffix}.info*.gz
%doc %{_infodir}/cppinternals%{binsuffix}.info*.gz
%doc %{_infodir}/gcc%{binsuffix}.info*.gz
%doc %{_infodir}/gccint%{binsuffix}.info*.gz
%doc %{_infodir}/gccinstall%{binsuffix}.info*.gz
%doc %{_infodir}/libgomp%{binsuffix}.info*.gz
%if %{build_fortran}
%doc %{_infodir}/gfortran%{binsuffix}.info*.gz
%ifarch %quadmath_arch
%doc %{_infodir}/libquadmath%{binsuffix}.info*.gz
%endif
%endif
%if %{build_java}
%doc %{_infodir}/gcj%{binsuffix}.info*.gz
%endif
%if %{build_ada}
%doc %{_infodir}/gnat-style%{binsuffix}.info*gz
%doc %{_infodir}/gnat_rm%{binsuffix}.info*gz
%doc %{_infodir}/gnat_ugn%{binsuffix}.info*gz
%endif

%files -n cpp47
%defattr(-,root,root)
%dir %{_libdir}/gcc
%dir %{_libdir}/gcc/%{GCCDIST}
%dir %{libsubdir}
%{_prefix}/bin/cpp%{binsuffix}
%{libsubdir}/cc1
#%{libsubdir}/specs
%doc %{_mandir}/man1/cpp%{binsuffix}.1.gz

%if %{build_objc}

%files objc
%defattr(-,root,root)
%{libsubdir}/cc1obj
%{libsubdir}/include/objc
%versmainlib libobjc.a

%versmainlib libobjc.so


%if %{separate_biarch}

%files objc%{separate_biarch_suffix}
%defattr(-,root,root)
%versbiarchlib libobjc.a

%versbiarchlib libobjc.so

%endif

%files -n libobjc%{libobjc_sover}
%defattr(-,root,root)
%mainlib libobjc.so.%{libobjc_sover}*


%if %{separate_biarch}

%files -n libobjc%{libobjc_sover}%{separate_biarch_suffix}
%defattr(-,root,root)
%biarchlib libobjc.so.%{libobjc_sover}*

%endif
%endif

%if %{build_objcp}

%files obj-c++
%defattr(-,root,root)
%{libsubdir}/cc1objplus
%endif

%if %{build_ada}

%files ada
%defattr(-,root,root)
%dir %{_libdir}/gcc
%dir %{_libdir}/gcc/%{GCCDIST}
%dir %{libsubdir}
%{_prefix}/bin/gnat*
%dir %{versmainlibdir}/adainclude
%dir %{versmainlibdir}/adalib
%{versmainlibdir}/adainclude
%{versmainlibdir}/adalib/*.ali
%{versmainlibdir}/adalib/*.a
%{versmainlibdir}/adalib/libgnarl.so
%{versmainlibdir}/adalib/libgnat.so
%{versmainlibdir}/gnat1

%if %{separate_biarch}

%files ada%{separate_biarch_suffix}
%defattr(-,root,root)
%dir %{versmainlibdirbi}/adainclude
%dir %{versmainlibdirbi}/adalib
%{versmainlibdirbi}/adainclude
%{versmainlibdirbi}/adalib/*.ali
%{versmainlibdirbi}/adalib/*.a
%{versmainlibdirbi}/adalib/libgnarl.so
%{versmainlibdirbi}/adalib/libgnat.so
%endif

%files -n libada47
%defattr(-,root,root)
%mainlib libgnarl-*.so

%mainlib libgnat-*.so


%if %{separate_biarch}

%files -n libada47%{separate_biarch_suffix}
%defattr(-,root,root)
%biarchlib libgnarl-*.so

%biarchlib libgnat-*.so

%endif
%endif
# LIBJAVA-DELETE-END

%if %{build_java}
%if 0%{?building_libjava:1}

%files -n gcc47-java
%defattr(-,root,root)
%{_prefix}/bin/gcj%{binsuffix}
%{_prefix}/bin/gcjh%{binsuffix}
%{_prefix}/bin/gcj-dbtool%{binsuffix}
%{_prefix}/bin/jcf-dump%{binsuffix}
%{_prefix}/bin/jv-convert%{binsuffix}
%{_prefix}/bin/gc-analyze%{binsuffix}
%{_prefix}/bin/aot-compile%{binsuffix}
%{_prefix}/bin/rebuild-gcj-db%{binsuffix}
%{libsubdir}/jc1
%{libsubdir}/jvgenmain
%{libsubdir}/ecj.jar
%{libsubdir}/ecj1
%doc %{_mandir}/man1/gcj%{binsuffix}.1.gz
%doc %{_mandir}/man1/gcjh%{binsuffix}.1.gz
%doc %{_mandir}/man1/gcj-dbtool%{binsuffix}.1.gz
%doc %{_mandir}/man1/jcf-dump%{binsuffix}.1.gz
%doc %{_mandir}/man1/jv-convert%{binsuffix}.1.gz
%doc %{_mandir}/man1/gc-analyze%{binsuffix}.1.gz
%doc %{_mandir}/man1/aot-compile%{binsuffix}.1.gz
%doc %{_mandir}/man1/rebuild-gcj-db%{binsuffix}.1.gz
%endif
%endif

%if %{build_java}
%if %{build_libjava}

%files -n libgcj47
%defattr(-,root,root)
%dir %{_libdir}/gcj-%{gcc_dir_version}-%{gcj_sover}
%dir %{_libdir}/gcc
%dir %{_libdir}/gcc/%{GCCDIST}
%dir %{libsubdir}
%{_libdir}/gcj-%{gcc_dir_version}-%{gcj_sover}/classmap.db
# We usually do not multilib libjava
%if %{biarch_libjava}
%versbiarchlib libgcj.la

%biarchlib libgcj.so.*

%biarchlib libgij.so.*

%biarchlib libgcj-tools.so.*

%else
%versmainlib libgcj.la

%mainlib libgcj.so.*

%mainlib libgij.so.*

%mainlib libgcj-tools.so.*

%endif
%{_libdir}/gcj-%{gcc_dir_version}-%{gcj_sover}/libjvm.la
%{_libdir}/gcj-%{gcc_dir_version}-%{gcj_sover}/libjvm.so
%{_libdir}/gcj-%{gcc_dir_version}-%{gcj_sover}/libjavamath.la
%{_libdir}/gcj-%{gcc_dir_version}-%{gcj_sover}/libjavamath.so

%files -n libgcj_bc%{libgcj_bc_sover}
%defattr(-,root,root)
%if %{biarch_libjava}
%biarchlib libgcj_bc.so.%{libgcj_bc_sover}*

%else
%mainlib libgcj_bc.so.%{libgcj_bc_sover}*

%endif

%files -n libgcj47-jar
%defattr(-,root,root)
%{_prefix}/share/java/libgcj-%{gcc_dir_version}.jar
%{_prefix}/share/java/libgcj-tools-%{gcc_dir_version}.jar

%files -n libgcj47-devel
%defattr(-,root,root)
%dir %{_prefix}/include/c++
%dir %{libsubdir}
%dir %{libsubdir}/include
%dir %{gxxinclude}
%{_libdir}/pkgconfig/libgcj%{binsuffix}.pc
%{libsubdir}/include/jawt.h
%{libsubdir}/include/jawt_md.h
%{libsubdir}/include/jni.h
%{libsubdir}/include/jni_md.h
%{libsubdir}/include/jvmpi.h
%{gxxinclude}/gnu
%{gxxinclude}/gcj
%{gxxinclude}/java
%{gxxinclude}/javax
%{gxxinclude}/org
%{gxxinclude}/sun
%{libsubdir}/include/gcj
%if %{biarch_libjava}
%versbiarchlib libgcj.so

%versbiarchlib libgcj.spec

%versbiarchlib libgcj-tools.so

%versbiarchlib libgij.so

%versbiarchlib libgcj_bc.so

%else
%versmainlib libgcj.so

%versmainlib libgcj.spec

%versmainlib libgcj-tools.so

%versmainlib libgij.so

%versmainlib libgcj_bc.so

%endif

%files -n gcc47-gij
%defattr(-,root,root)
%{_prefix}/bin/gij%{binsuffix}
%{_prefix}/bin/gappletviewer%{binsuffix}
%{_prefix}/bin/gjar%{binsuffix}
%{_prefix}/bin/gjarsigner%{binsuffix}
%{_prefix}/bin/gjavah%{binsuffix}
%{_prefix}/bin/gkeytool%{binsuffix}
%{_prefix}/bin/gnative2ascii%{binsuffix}
%{_prefix}/bin/gorbd%{binsuffix}
%{_prefix}/bin/grmic%{binsuffix}
%{_prefix}/bin/grmid%{binsuffix}
%{_prefix}/bin/grmiregistry%{binsuffix}
%{_prefix}/bin/gserialver%{binsuffix}
%{_prefix}/bin/gtnameserv%{binsuffix}
%doc %{_mandir}/man1/gij%{binsuffix}.1.gz
%doc %{_mandir}/man1/gappletviewer%{binsuffix}.1.gz
%doc %{_mandir}/man1/grmic%{binsuffix}.1.gz
%doc %{_mandir}/man1/grmid%{binsuffix}.1.gz
%doc %{_mandir}/man1/grmiregistry%{binsuffix}.1.gz
%doc %{_mandir}/man1/gkeytool%{binsuffix}.1.gz
%doc %{_mandir}/man1/gjar%{binsuffix}.1.gz
%doc %{_mandir}/man1/gjarsigner%{binsuffix}.1.gz
%doc %{_mandir}/man1/gjavah%{binsuffix}.1.gz
%doc %{_mandir}/man1/gnative2ascii%{binsuffix}.1.gz
%doc %{_mandir}/man1/gorbd%{binsuffix}.1.gz
%doc %{_mandir}/man1/gserialver%{binsuffix}.1.gz
%doc %{_mandir}/man1/gtnameserv%{binsuffix}.1.gz
%endif
%endif
# LIBFFI-DELETE-END

%if %{build_java}
%if 0%{?building_libffi:1}

%files -n libffi47
%defattr(-,root,root)
%mainlib libffi.so.%{libffi_sover}*


%if %{separate_biarch}

%files -n libffi47%{separate_biarch_suffix}
%defattr(-,root,root)
%biarchlib libffi.so.%{libffi_sover}*

%endif

%files -n libffi47-devel
%defattr(-,root,root)
%{_prefix}/include/ffi.h
%{_prefix}/include/ffitarget.h
%mainlib libffi.so

%mainlib libffi.a

%{_libdir}/pkgconfig/libffi.pc
%doc %{_mandir}/man3/ffi%{binsuffix}.3.gz
%doc %{_mandir}/man3/ffi_call%{binsuffix}.3.gz
%doc %{_mandir}/man3/ffi_prep_cif%{binsuffix}.3.gz

%if %{separate_biarch}

%files -n libffi47-devel%{separate_biarch_suffix}
%defattr(-,root,root)
%biarchlib libffi.so

%biarchlib libffi.a

%endif
%endif
%endif
# GCC-TESTSUITE-DELETE-END

%if 0%{?run_tests:1}

%files -n gcc47-testresults
%defattr(-,root,root)
%doc testresults/test_summary.txt
%doc testresults/*.sum
%doc testresults/*.log
%endif

%changelog
* Fri Feb  8 2013 rguenther@suse.com
- Add basic support for zEC12.  [fate#314830] [bnc#801424]
* Wed Feb  6 2013 rguenther@suse.com
- For s390 and s390x revert back to code generation for z900.
* Thu Jan 17 2013 matz@suse.de
- Add basic support for btver2 processor.  [fate #314170]
* Thu Jan 17 2013 rguenther@suse.com
- Configure with --disabe-initfini-array to avoid using .init_array
  and .fini_array.
* Tue Jan  8 2013 rguenther@suse.com
- Update to gcc-4_7-branch head (r195014).
  * fixes various bugs
* Wed Dec  5 2012 rguenther@suse.com
- Provide libgcc1 from libgcc_s1 for compatibility.
* Thu Nov 29 2012 matz@suse.de
- Fix baselibs.conf to mention libgcc_s1, not libgcc1.
* Wed Nov 21 2012 matz@suse.de
- Submit for SLE11 SP3, only c, c++ and fortran enabled.
  [fate #314169]
* Tue Oct 23 2012 rguenther@suse.com
- Transition the first set of shared library packages to follow the
  shared library policy.
- rename armv5el packages to official armv5tel name to avoid
  compat symlinks
* Tue Oct 23 2012 rguenther@suse.com
- Rip out support to build an optional compiler.
* Thu Sep 20 2012 rguenther@suse.com
- Update to gcc-4_7-branch head (r191568).
  * Includes GCC 4.7.2 release with bugfixes.
* Tue Sep  4 2012 schwab@linux-m68k.org
- Make ppc and ppc64 configurations the same execpt for default target.
* Mon Jul 30 2012 rguenther@suse.com
- Do not enable thumb by default for arm7.
- Update BuildRequires for cross compiler builds.
- Drop libmpc2 requires.
* Wed Jul 25 2012 rguenther@suse.com
- Use --with-build-sysroot=/ for icecream crosses, provide
  a real sysroot at /usr/target and adjust the g++ include path
  accordingly.
- Properly honor the -gnueabi suffix for arm.
* Mon Jul 23 2012 rguenther@suse.com
- Update to gcc-4_7-branch head (r189773).
  * Includes fix for PR54038.  [bnc#772488]
* Wed Jul 18 2012 rguenther@suse.com
- BuildRequire makeinfo instead of texinfo for openSUSE 12.3 and beyond.
* Tue Jul 17 2012 jengelh@inai.de
- Add SPARC to the list of arches not to package quadmath for.
  Change the exclusive list to an inclusive list for where it
  should be packaged (smaller list).
- Add SPARC visintrin.h to filelist
* Tue Jul 17 2012 rguenther@suse.com
- Update to gcc-4_7-branch head (r189603).
  * Fixes issue wiht DR1402 resolution.
  * Fixes PR53995.
* Fri Jul 13 2012 rguenther@suse.com
- Update to gcc-4_7-branch head (r189457).
  * Changes the C++11 ABI of std::list objects back to that of C++98
    like it was in GCC 4.6.
  * Changes the C++11 ABI of std::pair objects back to that of C++98
    like it was in GCC 4.6.  Fixes DR1402 to make that work.
* Fri Jun 29 2012 rguenther@suse.com
- Adjust arm icecream cross for continued change of the canonical
  target used in binutils.
* Tue Jun 26 2012 rguenther@suse.com
- Require a version of libquadmath0 at least as new as the
  libgfortran3 library from the latter.  [bnc#768785]
* Fri Jun 22 2012 adrian@suse.de
- complete armv7hl switch
* Wed Jun 20 2012 aj@suse.de
- Use new dynamic linker path /lib/ld-linux-armhf.so.3 for ARM v7.
* Tue Jun 19 2012 coolo@suse.com
- do not build cross environments on architectures that
  are not native
* Fri Jun 15 2012 rguenther@suse.com
- Update to gcc-4_7-branch head (r188649).
  * Includes GCC 4.7.1 release.
* Wed Jun  6 2012 rguenther@suse.com
- Explicitely specify target tools used for building.
* Mon Jun  4 2012 rguenther@suse.com
- Update to gcc-4_7-branch head (r188177).
* Fri Jun  1 2012 rguenther@suse.com
- Fix typo in cross-icecream.spec.in.
- Also dump test-summary to the build log.
* Wed May 30 2012 rguenther@suse.com
- Update patch for PR52080.
* Mon May  7 2012 rguenther@suse.com
- Update to gcc-4_7-branch head (r187228).
- Add patch for PR52841.
* Thu Apr 19 2012 rguenther@suse.com
- Fix canonicalized target names for crosses.
- Enable icecream backends, make their package name version specific.
* Fri Apr 13 2012 rguenther@suse.com
- Update to gcc-4_7-branch head (r186417).
- Fix libstdc++.so-gdb.py autoload script.  [bnc#750960]
- Drop to release checking.
- Fix build of cross targets with canonicalized name.
* Thu Mar 22 2012 rguenther@suse.com
- Update to GCC 4.7.0 release.
- Update to gcc-4_7-branch head (r185687).
* Tue Mar 20 2012 rguenther@suse.com
- Package the gdb python scripts.  [bnc#750960]
* Mon Mar 19 2012 rguenther@suse.com
- Change armv5 to use soft floating-point.
* Tue Mar 13 2012 rguenther@suse.com
- Update to gcc-4_7-branch head (r185330).
* Fri Mar  2 2012 rguenther@suse.com
- Update to GCC 4.7.0 release candidate.
- Fixup libstdc++v3 symbol baselines on powerpc.
* Wed Feb 29 2012 rguenther@suse.com
- Fixup more SPDX license issues.
* Tue Feb 28 2012 rguenther@suse.com
- Update to SVN trunk head (r184624).
- Merge changes from GCC 4.6 package.
* Fri Feb 24 2012 rguenther@suse.com
- Update to SVN trunk head (r184541).
* Tue Feb 21 2012 rguenther@suse.com
- Update to SVN trunk head (r184435).
- Merge changes from GCC 4.6 package.
- Add patches for PR49484 and PR52080.
* Wed Feb  8 2012 rguenther@suse.com
- Update to SVN trunk head (r184004).
* Tue Jan 31 2012 rguenther@suse.com
- Update to SVN trunk head (r183753).
- Merge changes from GCC 4.6 package.
* Tue Jan 24 2012 rguenther@suse.com
- Drop AWT support from libgcj.  [bnc#742935]
* Wed Jan 18 2012 rguenther@suse.com
- Update to SVN trunk head (r183273).
* Wed Jan 11 2012 rguenther@suse.com
- Update to SVN trunk head (r183092).
- Merge changes from GCC 4.6 package.
* Wed Jan  4 2012 rguenther@suse.com
- Update to SVN trunk head (r182872).
* Tue Dec 20 2011 rguenther@suse.com
- Update to SVN trunk head (r182525).
* Sun Dec 18 2011 adrian@suse.de
- fix file list for arm architecture
* Thu Nov  3 2011 rguenther@suse.com
- New package.
